package com.mxnavi.tspv2.core;

import com.google.gson.Gson;
import com.mxnavi.tspv2.model.LatLng;
import com.mxnavi.tspv2.notification.NotificationListener;
import com.mxnavi.tspv2.notification.model.Birthday;
import com.mxnavi.tspv2.notification.model.CommandContent;
import com.mxnavi.tspv2.notification.model.DrivingRecordNotice;
import com.mxnavi.tspv2.notification.model.LoginData;
import com.mxnavi.tspv2.notification.model.LoginDataInfo;
import com.mxnavi.tspv2.notification.model.MessageBindContent;
import com.mxnavi.tspv2.notification.model.MessageBindItem;
import com.mxnavi.tspv2.notification.model.MessageInfo;
import com.mxnavi.tspv2.notification.model.MessageItem;
import com.mxnavi.tspv2.notification.model.MessagePoiContent;
import com.mxnavi.tspv2.notification.model.MessagePoiItem;
import com.mxnavi.tspv2.notification.model.ReqBody;
import com.mxnavi.tspv2.notification.model.ReqHeader;
import com.mxnavi.tspv2.notification.model.UserInfoResult;
import com.mxnavi.tspv2.notification.model.WeChatUserInfo;
import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Administrator on 2016/5/26.
 * desc
 */
public class Notification {
    public static void initNotificationListener(){
        ResponseDispathUtil.setNotificationListener(noticeListener);
    }
    private static NotificationListener mNotificationListener;
    public static void setNotificationListener(NotificationListener notificationListener){
        mNotificationListener = notificationListener;
    }
    static ResponseDispathUtil.NoticeListener noticeListener = new ResponseDispathUtil.NoticeListener(){
        @Override
        public void onReceiveNotice(int serviceType,String notice){
            if(serviceType ==  Config.MxNGTPServiceType.SEND_TO_CAR.getServiceType()){
                noticeSendToCar(notice);
            }else if(serviceType ==  Config.MxNGTPServiceType.MX_USER_MANAGE.getServiceType()){
                noticeUser3rdLogin(notice);
            }else if(serviceType ==  Config.MxNGTPServiceType.REMOTE_CONTROL.getServiceType()){
                noticeDrivingRecord(notice);
            }

        }
    };
    private static void noticeDrivingRecord(String notice){
        JSONTokener jsonParser = new JSONTokener(notice);

        try {
            JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
            if(jsonObject.has("reqBody")){//远程控制消息
                Gson gson = new Gson();
                ReqHeader reqHeader = gson.fromJson(jsonObject.getJSONObject("reqHeader").toString(), ReqHeader.class);
                ReqBody reqBody = gson.fromJson(jsonObject.getJSONObject("reqBody").toString(), ReqBody.class);
                JSONObject bodyJson = jsonObject.getJSONObject("reqBody");
                if(bodyJson.has("data")){
                    String dataStr = bodyJson.getString("data");
                    if(!"null".equalsIgnoreCase(dataStr)){
                        reqBody.setDataJsonStr(dataStr);
                    }
                }

                if(mNotificationListener!=null){
                    mNotificationListener.onReceiveRemoteControlNotice(reqHeader,reqBody);
                }
            }else{
                DrivingRecordNotice drivingRecordNotice = new DrivingRecordNotice();
                drivingRecordNotice.setCommandType(jsonObject.getInt("command"));
                drivingRecordNotice.setCommandTime(jsonObject.getLong("commandTime"));
                drivingRecordNotice.setNotifyURL(jsonObject.getString("notifyURL"));
                CommandContent commandContent = new CommandContent();
                JSONObject contentObj =  jsonObject.getJSONObject("content");
                commandContent.setId(contentObj.getString("id"));
                commandContent.setOpenId(contentObj.getString("openId"));
                drivingRecordNotice.setCommandContent(commandContent);
                if(mNotificationListener!=null){
                    mNotificationListener.onReceiveDrivingRecordNotice(drivingRecordNotice);
                }
            }
        }catch (JSONException e){

        }
    }
    private static void noticeUser3rdLogin(String notice){
        JSONTokener jsonParser = new JSONTokener(notice);
        try {

            JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
            JSONObject dataObject  = jsonObject.getJSONObject("data");
            LoginData loginData = new LoginData();

            LoginDataInfo loginInfo = new LoginDataInfo();
            UserInfoResult user = new UserInfoResult();
            JSONObject loginInfoObj  = dataObject.getJSONObject("loginInfo");
            loginInfo.setToken(loginInfoObj.getString("token"));
            loginInfo.setRefreshToken(loginInfoObj.getString("refreshToken"));
            loginInfo.setExpired(loginInfoObj.getInt("expired"));
            loginData.setLoginInfo(loginInfo);
            JSONObject userObj  = dataObject.getJSONObject("user");

            if(userObj.has("id")){
                String id = userObj.getString("id");
                user.setAcUserId(id);
            }
            if(userObj.has("name")){
                String name = userObj.getString("name");
                user.setAcUserName(name);
            }
            if(userObj.has("nickname")){
                String nickname = userObj.getString("nickname");
                user.setNickname(nickname);
            }
            if(userObj.has("avatar")){
                String avatar = userObj.getString("avatar");
                user.setAvatar(avatar);
            }
            if(userObj.has("birthday")){
                String strBirthday = userObj.getString("birthday");
                Birthday birthday = new Birthday();
                if (!Utils.strIsEmpty(strBirthday)) {
                    String[] strArry = strBirthday.split("-");
                    if(strArry.length == 3){
                        birthday.setDay(Integer.parseInt(strArry[2]));
                        birthday.setMonth(Integer.parseInt(strArry[1]));
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    }else if(strArry.length == 2){
                        birthday.setMonth(Integer.parseInt(strArry[1]));
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    }else if (strArry.length == 1) {
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    }

                }
                user.setBirthday(birthday);
            }
            if(userObj.has("sex")){
                int gender = userObj.getInt("sex");
                user.setGender(gender);
            }
            if(userObj.has("location")){
                String location = userObj.getString("location");
                user.setLocation(location);
            }
            if(userObj.has("phone")){
                String phone = userObj.getString("phone");
                user.setPhone(phone);
            }
            if(userObj.has("mail")){
                String mail = userObj.getString("mail");
                user.setEmail(mail);
            }
            loginData.setUser(user);
            if(mNotificationListener!=null){
                mNotificationListener.onReceiveUserLoginNotice(loginData);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }



    }
    public static void noticeSendToCar(String notice){
        Utils.loge(notice);
        // 解析完通知内容回调APP通知接口
        List<MessagePoiItem> poiList = new ArrayList<MessagePoiItem>();
        List<MessageBindItem> bindList = new ArrayList<MessageBindItem>();
        List<MessageItem> msgList = new ArrayList<MessageItem>();

        JSONTokener jsonParser = new JSONTokener(notice);
        try {
            JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
            int respCode = jsonObject.getInt("respCode");
            if (respCode == Constants.RESPCODE_SUCCESS) {
                String weChatCarId = null;
                if (jsonObject.has("wecarId")) {
                    weChatCarId = Utils.converNullToEmpty(jsonObject.getString("wecarId"));
                }
                JSONArray array = jsonObject.getJSONArray("contentList");
                MessagePoiItem poiresult;
                MessageBindItem bindresult;
                MessageItem msgItem;

                for (int i = 0; i < array.length(); i++) {
                    JSONObject object = array.getJSONObject(i);
                    JSONObject content =object.getJSONObject("content");
                    //为了解决兼容两个版本文档回调2018.4.8
                    String msgType =null;
                    if (object.has("msgType")){
                        msgType = Utils.converNullToEmpty(object.getString("msgType"));
                    }
                    String msgSubtype =null;
                    if (object.has("msgSubtype")){
                        msgSubtype = Utils.converNullToEmpty(object.getString("msgSubtype"));
                    }
                    String type =null;
                    if (jsonObject.has("wecarId")){
                        type = msgSubtype;
                    }else {
                        type = msgType;
                    }

                    if("poi".equals(type)){
                        poiresult = new MessagePoiItem();
                        MessagePoiContent poicontent = new MessagePoiContent();
//                        if(content.has("source")){
//                            poicontent.setSource(content.getString("source"));
//                        }
                        if(content.has("name")){
                            poicontent.setName(content.getString("name"));
                        }//1
                        if(content.has("address")){
                            poicontent.setAddress(content.getString("address"));
                        }//2
                        LatLng latLng =new LatLng();
                        if(content.has("lat")){
                            latLng.setLatitude(content.getDouble("lat"));
                        }//3
                        if(content.has("lng")){
                            latLng.setLongitude(content.getDouble("lng"));
                        }//4
                        poicontent.setLatLng(latLng);
                        //如果msg有值，为路畅演示功能所用2018.4.9 by chika
                        if(content.has("msg")){
                            poicontent.setMsg(content.getString("msg"));
                        }//5
//                        LatLng maxLatLng =new LatLng();
//                        if(content.has("mxLat")){
//                            maxLatLng.setLatitude(content.getDouble("mxLat"));
//                        }
//                        if(content.has("mxLng")){
//                            maxLatLng.setLongitude(content.getDouble("mxLng"));
//                        }
//                        poicontent.setMaxLatLng(maxLatLng);
//                        if(content.has("phone")){
//                            poicontent.setPhone(content.getString("phone"));
//                        }
//                        WeChatUserInfo weChatUserInfo = new WeChatUserInfo();
//                        if(content.has("sex")&&!"".equals(content.getString("sex"))){
//                            weChatUserInfo.setSex(content.getInt("sex"));
//                        }
//                        if(content.has("region")){
//                            weChatUserInfo.setRegion(content.getString("region"));
//                        }
//                        if(content.has("province")){
//                            weChatUserInfo.setProvince(content.getString("province"));
//                        }
//                        if(content.has("language")){
//                            weChatUserInfo.setLanguage(content.getString("language"));
//                        }
//                        if(content.has("nickName")){
//                            weChatUserInfo.setNickNname(content.getString("nickName"));
//                        }
//                        if(content.has("city")){
//                            weChatUserInfo.setCity(content.getString("city"));
//                        }
//                        if(content.has("country")){
//                            weChatUserInfo.setCountry(content.getString("country"));
//                        }
//                        if(content.has("headImgUrl")){
//                            weChatUserInfo.setHeadmgurl(content.getString("headImgUrl"));
//                        }
//                        poicontent.setWeChatUserInfo(weChatUserInfo);
//                        if(content.has("precision")){
//                            poicontent.setPrecision(content.getString("precision"));
//                        }
//                        if(content.has("similar")){
//                            poicontent.setSimilar(content.getInt("similar"));
//                        }
//                        if(content.has("openid")){
//                            poicontent.setOpenId(Utils.converNullToEmpty(content.getString("openid")));
//                        }
//                        if(content.has("groupid")){
//                            poicontent.setGroupId(Utils.converNullToEmpty(content.getString("groupid")));
//                        }
                        poiresult.setContent(poicontent);
//                        if (object.has("createTime")) {
//                            poiresult.setCreateTime(object.getLong("createTime"));
//                        }
//                        MessageInfo msginfo = new MessageInfo();
//                        if(object.has("weixinOpenid")){
//                            msginfo.setWeChatOpenId(Utils.converNullToEmpty(object.getString("weixinOpenid")));
//                        }
//                        if(object.has("msgType")){
//                            msginfo.setMsgType(Utils.converNullToEmpty(object.getString("msgType")));
//                        }
//                        if(object.has("msgSubtype")){
//                            msginfo.setMsgSubtype(Utils.converNullToEmpty(object.getString("msgSubtype")));
//                        }
//                        if(object.has("msgId")){
//                            msginfo.setMsgId(Utils.converNullToEmpty(object.getString("msgId")));
//                        }
//                        poiresult.setMessageInfo(msginfo);
                        poiList.add(poiresult);
                    } else if("demo".equals(type)) {
                        msgItem = new MessageItem();
                        if(content.has("type")){
                            msgItem.setType(content.getString("type"));
                        }
                        if(content.has("msg")){
                            msgItem.setMsg(content.getString("msg"));
                        }
                        msgList.add(msgItem);
                        if(mNotificationListener!=null){
                            mNotificationListener.onReceiveSendToCarMessage(msgList);
                            return;
                        }
                    } else {
                        bindresult = new MessageBindItem();
                        MessageBindContent bindContent = new  MessageBindContent();
                        if (content.has("bindStatus")){
                            bindContent.setBindStatus(content.getString("bindStatus"));
                        }
                        if (content.has("userId")){
                            bindContent.setUserId(content.getString("userId"));
                        }
                        bindresult.setContent(bindContent);
                        //bindresult.setCreateTime(object.getLong("createTime"));
                        MessageInfo msginfo = new MessageInfo();
                        if(object.has("weixinOpenid")){
                            msginfo.setWeChatOpenId(Utils.converNullToEmpty(object.getString("weixinOpenid")));
                        }
                        if(object.has("msgType")){
                            msginfo.setMsgType(Utils.converNullToEmpty(object.getString("msgType")));
                        }
                        if(object.has("msgSubtype")){
                            msginfo.setMsgSubtype(Utils.converNullToEmpty(object.getString("msgSubtype")));
                        }
                        if(object.has("msgId")){
                            msginfo.setMsgId(Utils.converNullToEmpty(object.getString("msgId")));
                        }
                        bindresult.setMessageInfo(msginfo);
                        bindList.add(bindresult);
                    }

                }
                if(mNotificationListener!=null){
                    mNotificationListener.onReceiveSendToCarNotice(weChatCarId,poiList,bindList);
                }

            }else{
                String errorMsg = jsonObject.getString("errmsg");

            }
        } catch (Exception e) {
            e.printStackTrace();

        }
    }
}
