package com.mxnavi.tspv2.core;



import android.os.Bundle;

import com.google.protobuf.ByteString;
import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.tsp.TSP;
import com.mxnavi.tspv2.utils.Utils;




/**
 * Created by Administrator on 2016/4/1.
 * desc
 */
public class ResponseDispathUtil {
    private ResponseDispathUtil() {
//        init();
    }
    private static ResponseDispathUtil instance = new ResponseDispathUtil();
    public static ResponseDispathUtil instance() {
        return instance;
    }

    public  void disPathResponse(MxNGTPMessage.MxMessage mxMessage){
        MxNGTPMessage.NGTPDispatcherData dispatcherData = mxMessage.getNgtpMessage().getDispatcherData();
        MxNGTPMessage.DSPTMessageType dSPTMessageType = dispatcherData.getDsptMessageType();
//        MxNGTPMessage.ServiceType serviceType = MessageBuilder.instance().getServiceType(dispatcherData);

        int requestHandleId = MessageBuilder.instance().getRequestHandleId(dispatcherData);
        RequestDispathUtil.onFinishRequest(requestHandleId);
        try{
            String disp = dispatcherData.toString();
            Utils.loge(disp);
        }catch(Exception e){
            e.printStackTrace();
        }
        if(dispatcherData.hasErrorCode()){// 返回错误信息
            int intErrorCode = dispatcherData.getErrorCode().getNumber();
            String errorMsg = "";
            if(intErrorCode!=Constants.DSPT_UNKNOWN_ERROR_CODE&&intErrorCode>=0
                    &&intErrorCode< Constants.DSPT_ERROR_MSG.length){
                errorMsg = Constants.DSPT_ERROR_MSG[intErrorCode];
            }else if(intErrorCode == Constants.DSPT_UNKNOWN_ERROR_CODE){
                errorMsg = Constants.DSPT_UNKNOWN_ERROR;
            }
            // token失效或者用户不存在，调用统一的回调接口
            if (intErrorCode == Constants.CUSTOMER_TOKEN_INVALID_VALUE
                            && mUserTokenExpireListener !=null){
                mUserTokenExpireListener.onUserTokenExpire();
                return;
            }else if(intErrorCode == Constants.USER_ID_INVALID_VALUE
                            && mUserTokenExpireListener !=null){
                mUserTokenExpireListener.onUserInvalid();
                return;
            }else if (intErrorCode == Constants.USER_KICKED_OUT
                    && mUserTokenExpireListener !=null){
                mUserTokenExpireListener.onUserKickedOut();
                return;
            }

            BaseTsp baseTsp =  BaseTsp.requestMap.get(requestHandleId);
             if(baseTsp!=null){
                baseTsp.sendResponseMsg(requestHandleId,BaseTsp.ERROR_MSG_TYPE,errorMsg);
//                Message message = handler.obtainMessage();
//                message.arg1 =requestHandleId;
//                message.what = BaseTsp.ERROR_MSG_TYPE;
//                message.obj = errorMsg;
//
//                message.sendToTarget();

//                baseTsp.onCallBack(requestHandleId,"",true,Constants.ERROR_CODE_DSPT,errorMsg);
            }

            return;
        }
        int serviceDataEncoding = dispatcherData.getServiceDataEncoding();
        String responseTxt = "";
        ByteString serviceByteData = null;
        if(MessageBuilder.ENCODINGTYPE_PLAIN_TEXT == serviceDataEncoding || MessageBuilder.ENCODINGTYPE_JSON_UTF8 == serviceDataEncoding || MessageBuilder.ENCODINGTYPE_FORM_DATA == serviceDataEncoding){
            try {
                responseTxt = MessageBuilder.instance().getServiceData(mxMessage);

            }catch (Exception e){
                e.printStackTrace();
            }
        }else if(MessageBuilder.ENCODINGTYPE_PROTOBUF == serviceDataEncoding){

            try {
                serviceByteData = MessageBuilder.instance().getServiceByteData(mxMessage.getNgtpMessage());
            } catch (Exception e) {
                e.printStackTrace();
            }

        }
//        Utils.loge("receivemessage eventId = "+requestHandleId);
        if(dSPTMessageType.getNumber() ==  MxNGTPMessage.DSPTMessageType .NOTIFICATION.getNumber()){// 通知
           int serviceType =  dispatcherData.getServiceType();
            if(mNoticeListener!=null){
                mNoticeListener.onReceiveNotice(serviceType,responseTxt);
            }
//            Message message = handler.obtainMessage();
//            message.arg1 =requestHandleId;
//            message.what = BaseTsp.NOTIFY_MSG_TYPE;
//            message.obj = responseTxt;
//            message.arg2 = serviceType.getNumber();
//
//            message.sendToTarget();

            return;
        }
        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestHandleId);
        if(baseTsp!=null) {
            if (MessageBuilder.ENCODINGTYPE_PLAIN_TEXT == serviceDataEncoding || MessageBuilder.ENCODINGTYPE_JSON_UTF8 == serviceDataEncoding || MessageBuilder.ENCODINGTYPE_FORM_DATA == serviceDataEncoding) {
                baseTsp.sendResponseMsg(requestHandleId,BaseTsp.STRING_MSG_TYPE,responseTxt);
//                Message message = handler.obtainMessage();
//                message.arg1 = requestHandleId;
//                message.what = BaseTsp.STRING_MSG_TYPE;
//                message.obj = responseTxt;
//
//                message.sendToTarget();
//                baseTsp.onCallBack(requestHandleId,responseTxt,false,0,null);
            } else if (MessageBuilder.ENCODINGTYPE_PROTOBUF == serviceDataEncoding) {
                baseTsp.sendResponseMsg(requestHandleId,BaseTsp.BYTE_MSG_TYPE,serviceByteData);
//                Message message = handler.obtainMessage();
//                message.arg1 = requestHandleId;
//                message.what = BaseTsp.BYTE_MSG_TYPE;
//                message.obj = serviceByteData;
//
//                message.sendToTarget();
//                baseTsp.onCallBack(requestHandleId,serviceByteData,false,0,null);
//            }

            }
        }

    }

    public static void setUserTokenExpireListener(TSP.UserTokenExpireListener userTokenExpireListener) {
        mUserTokenExpireListener = userTokenExpireListener;
    }
    private static TSP.UserTokenExpireListener mUserTokenExpireListener;


    public interface NoticeListener{
        public void onReceiveNotice(int serviceType, String notice);
    }
    private static NoticeListener mNoticeListener;
    protected static void setNotificationListener(NoticeListener noticeListener){
        mNoticeListener = noticeListener;
    }
    public  void disPathHttpResponse(int requestHandleId,int httpStatus){
        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestHandleId);
        if(baseTsp!=null){
            baseTsp.sendResponseMsg(requestHandleId,BaseTsp.HTTPERROR_MSG_TYPE,"");
        }
        RequestDispathUtil.onFinishRequest(requestHandleId);
    }
    public  void disPathHttpProgress(int requestHandleId,long bytesWritten, long totalSize){
        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestHandleId);
        if(baseTsp!=null){
            Bundle boundle = new Bundle();
            boundle.putLong("bytesWritten",bytesWritten);
            boundle.putLong("totalSize",totalSize);
            baseTsp.sendResponseMsg(requestHandleId,BaseTsp.ONPROGRESS_MSG_TYPE,boundle);
        }
        RequestDispathUtil.onFinishRequest(requestHandleId);
    }
}
