package com.mxnavi.tspv2.core;

import com.mxnavi.tspv2.utils.Utils;

import java.util.Iterator;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

/**
 * Created by Administrator on 2016/4/18.
 * desc
 */
public class TimeOut {
    private static ScheduledExecutorService service;
    static ScheduledFuture scheduledFuture;

    protected static  void startCheckTimeOut(){
        if(scheduledFuture == null){
        	synchronized(TimeOut.class){
        		if(scheduledFuture == null){
        			 service = Executors.newScheduledThreadPool(1,new TspThreadFactory("TimeOut"));
                     scheduledFuture = service.scheduleWithFixedDelay(checkTimeOutTask,0,10, TimeUnit.SECONDS);
        		}
        		 
        	}
        }else if(scheduledFuture.isCancelled()){
            scheduledFuture.notify();
        }

    }
    public static  void stopCheckTimeOut(){
        if(scheduledFuture!=null){
            scheduledFuture.cancel(true);
            service.shutdownNow();
            scheduledFuture = null;
            service = null;
        }

    }

    static Runnable checkTimeOutTask = new Runnable() {
        public void run(){
            for (PrioritizedRequestMessage msg: RequestDispathUtil.cacheQueue) {
                if(isTimeOut(msg)){
                    Utils.loge("cacheQueue timeout eventID==" + msg.evenId);
                    RequestDispathUtil.cacheQueue.remove(msg);
                    BaseTsp baseTsp =  BaseTsp.requestMap.get(msg.evenId);
                    if(baseTsp!=null) {
                        baseTsp.sendResponseMsg(msg.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
                    }
                }
            }
            if(!Connection.getInstance().READFILE_FINISH){
                return;
            }
            if(Config.hasTcpConnect>0){
                try {

                    if(RequestDispathUtil.tcpRequestHandler==null){
                        return;
                    }
                    for (PrioritizedRequestMessage msg: RequestDispathUtil.tcpRequestHandler.cacheQueue) {
                        if(isTimeOut(msg)){
//                        Utils.loge("cacheQueue timeout eventID==" + msg.evenId);
                            RequestDispathUtil.tcpRequestHandler.cacheQueue.remove(msg);
                            BaseTsp baseTsp =  BaseTsp.requestMap.get(msg.evenId);
                            if(baseTsp!=null) {
                                baseTsp.sendResponseMsg(msg.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
                            }
//                        Message message =  BaseTsp.handler.obtainMessage();
//                        message.arg1 = msg.evenId;
//                        message.what=BaseTsp.MESSAGE_TIMEOUT;
//                        message.sendToTarget();

                        }
                    }
                    for (PrioritizedRequestMessage msg: RequestDispathUtil.tcpRequestHandler.requestQueue) {
//                    Utils.loge("TcpRequestUtil.requestQueue.evenId()=="+msg.evenId+" msg.priority="+msg.priority);
                        if(isTimeOut(msg)){
//                        Utils.loge("requestQueue timeout eventID==" + msg.evenId);
                            RequestDispathUtil.tcpRequestHandler.requestQueue.remove(msg);
                            BaseTsp baseTsp =  BaseTsp.requestMap.get(msg.evenId);
                            if(baseTsp!=null) {
                                baseTsp.sendResponseMsg(msg.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
                            }
//                        Message message =  BaseTsp.handler.obtainMessage();
//                        message.arg1 = msg.evenId;
//                        message.what=BaseTsp.MESSAGE_TIMEOUT;
//                        message.sendToTarget();
                        }
                    }

                    Iterator<PrioritizedRequestMessage> iterator = RequestDispathUtil.tcpRequestHandler.processingMsgList.iterator();
//                Utils.loge("timeout ----start");
                    int hasHighPriorityRequestNum = 0;
                    int i = 0;
                    while (iterator.hasNext()) {
                        PrioritizedRequestMessage msg = iterator.next();
                        // 如果是高优先级的请求，需要判断是否等待时间超过阈值，如果超过，则判断在他前面是否有高优先的接口。如果没有就取消未发出的所有请求，重新排优先级重新发请求
//                    Utils.loge("processingMsgList.evenId==" + msg.evenId);
                        i++;
                        if (msg.priority == Config.PRIORITY_HIGH) {
                            if (System.currentTimeMillis() - msg.createTimeStamp >= Config.HIGH_PRIORITY_WAIT_TIME * 1000) {
                                if(hasHighPriorityRequestNum<=0&&i>1){// 如果自己不是第一个接口，且前面没有高优先级接口，则中断TCP连接，重新排优先级，重新连接重新发请求
                                    Utils.loge("hasHighPriorityRequest reConnection");
                                    RequestDispathUtil.tcpRequestHandler.reConnection();
                                    break;
                                }
                            }
                            hasHighPriorityRequestNum ++;
//                        Utils.loge("hasHighPriorityRequestNum eventID==" + msg.evenId);
                        }

                        if (isTimeOut(msg)) {
                            if (msg.priority == Config.PRIORITY_HIGH) {
                                hasHighPriorityRequestNum--;
                            }
//                        Utils.loge("timeout eventID==" + msg.evenId);
                            RequestDispathUtil.tcpRequestHandler.processingMsgList.remove(msg);
                            RequestDispathUtil.tcpRequestHandler.channelFutureMap.remove(msg.evenId);
                            // 超时
                            BaseTsp baseTsp =  BaseTsp.requestMap.get(msg.evenId);
                            if(baseTsp!=null) {
                                baseTsp.sendResponseMsg(msg.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
                            }
//                        Message message = BaseTsp.handler.obtainMessage();
//                        message.arg1 = msg.evenId;
//                        message.what = BaseTsp.MESSAGE_TIMEOUT;
//                        message.sendToTarget();
                        }
//                    Utils.loge("hasHighPriorityRequestNum==---"+hasHighPriorityRequestNum);
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                    Utils.loge("TimeOut-Exception");
                }
            }
            if(Config.hasHttpConnect>0){
                // 去掉对HTTP请求的超时检测，HTTP组件自动会超时

//                if (RequestDispathUtil.httpRequestHandler.linkedBlockingQueue.size()>0) {
//                    Utils.loge("linkedBlockingQueue.size="+ RequestDispathUtil.httpRequestHandler.linkedBlockingQueue.size());
//                    Runnable run = RequestDispathUtil.httpRequestHandler.linkedBlockingQueue.peek();
//                    PrioritizedRequestMessage msg = ((TspAsyncHttpRequest)run).prioritizedRequestMessage;
//                    Utils.loge("msg.priority ="+msg.priority);
//                    if (msg.priority == Config.PRIORITY_HIGH) {
//                        Utils.loge("http PRIORITY_HIGH");
//                        if (System.currentTimeMillis() - msg.createTimeStamp >= Config.HIGH_PRIORITY_WAIT_TIME * 1000) {
//
//                                Utils.loge("http hasHighPriorityRequest reConnection");
//                            RequestDispathUtil.httpRequestHandler.reConnection();
//
//
//                        }
//
//                    }
//                }
            }

        }

    };
    private static  boolean isTimeOut(PrioritizedRequestMessage msg){
        long createTimeStamp = msg.createTimeStamp;
        int timeOutSeconds = msg.timeOutSeconds;
        if(timeOutSeconds<=0) {
            timeOutSeconds = Config.DEFAULT_TIMEOUT_SECS;
        }
        if(System.currentTimeMillis()-createTimeStamp>=timeOutSeconds*1000){
            return true;
        }else{
            return false;
        }
    }
//    static Handler myHandler = new Handler() {
//        public void handleMessage(Message msg) {
//            if(msg.what==MESSAGE_TIMEOUT){
//                int requstId = msg.arg1;
//                BaseTsp baseTsp =  BaseTsp.requestMap.get(requstId);
//                if(baseTsp!=null){
//                    baseTsp.callTimeOut(requstId);
//                }
//                // 取消超时的请求
//                TcpRequestUtil.cancelRequest(requstId);
//            }
//
//        }
//    };


}
