/*
 * Copyright 2012 The Netty Project
 *
 * The Netty Project licenses this file to you under the Apache License,
 * version 2.0 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at:
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */
package com.mxnavi.tspv2.core.netty;

import android.util.Log;

import com.mxnavi.tspv2.core.MessageBuilder;
import com.mxnavi.tspv2.core.ResponseDispathUtil;
import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.utils.Utils;

import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

public class DSPTClientHandler extends SimpleChannelInboundHandler<Object> {

    public DSPTClientHandler() {
        super(false);
    }
        
    @Override
    public void channelRegistered(ChannelHandlerContext ctx) {
    }
    @Override
    public void channelActive(ChannelHandlerContext ctx) {
        ctx.channel().writeAndFlush(MessageBuilder.instance().makeLoginMessage());
        Utils.loge("channelActive=====");
    }
    @Override
    public void channelRead0(ChannelHandlerContext ctx, Object msg) throws Exception {
        messageReceived( ctx,msg);
    }

    public void messageReceived(ChannelHandlerContext ctx, Object obj) {
        try {
            MxNGTPMessage.MxMessage mxMessage = (MxNGTPMessage.MxMessage)obj;
//            MxNGTPMessage.MXMessageType messageType = mxMessage.getMessageType();
//
//            MxNGTPMessage.NGTPDispatcherData dispatcherData = mxMessage.getNgtpMessage().getDispatcherData();
//            MxNGTPMessage.DSPTMessageType DSPTMessageType = dispatcherData.getDsptMessageType();
//            if(DSPTMessageType.getNumber()==MxNGTPMessage.DSPTMessageType.LOGIN_ACK.getNumber()){//登录成功
//                System.out.println("DSPTClientHandler登录成功-----");
//                return;
//            }
//            Log.e("mxMessage",dispatcherData.toString());
//            MxNGTPMessage.ServiceType serviceType = MessageBuilder.instance().getServiceType(dispatcherData);
//            String responseTxt = MessageBuilder.instance().getServiceData(mxMessage);
//            if (responseTxt != null && responseTxt.length() > 0) {
//                System.out.println("service_data:"+responseTxt);
//            }
            ResponseDispathUtil.instance().disPathResponse(mxMessage);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) {
        cause.printStackTrace();
        ctx.close();
    }
}
