package com.mxnavi.tspv2.datashare;

import android.os.Environment;

import com.mxnavi.tspv2.datashare.model.ServerFileInfo;
import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * Created by Administrator on 2016/7/25.
 * desc
 */
public class DataShareServer {
    int port = 9999;
    int MAXLENGTH = 1024*40;
    boolean isStop = false;
    String currVer = "1.0";
    String matchVer= "1.0";
    final int MAGNO_BROADCAST = 1;
    final int MAGNO_SENDDEVICENO = 2;
    final int MAGNO_GETDATA = 3;
    final int MAGNO_SENDFILE_TOTALINFO = 4;
    final int MAGNO_SENDFILE_INFO = 5;
    final int MAGNO_SENDFILE = 6;
    final int MAGNO_NOTICE_FINISH = 7;

    int RESP_OK =200;
    int RESP_FILE_FINISH = 201;
    int RESP_MEMORY_NOT_ENOUGN = 300;
    int RESP_SERVER_ERROR = 500;
    int RESP_REFUSE = 304;
    int RESP_VALID_ERROR = 400;

    String respBroadcast = "{\"msgType\":1,\"msgNo\":"+MAGNO_BROADCAST+"," +
        "\"verMatch\":1,\"deviceName\":\"美行导航（conti）\",\"ptt\":\""+currVer+"\"" +
        "}";
    String respBroadcastNotMatch =  "{\"msgType\":1,\"msgNo\":"+MAGNO_BROADCAST+"," +
            "\"verMatch\":0,\"deviceName\":\"美行导航（conti）\",\"ptt\":\""+currVer+"\"" +
            "}";
    String respDeviceNo="{\"msgType\":1,\"msgNo\":"+MAGNO_SENDDEVICENO+"}";
    String respGetData ="{\"msgType\":1,\"msgNo\":"+MAGNO_GETDATA+"," +" \"info\":{\"xxxx\":\"xxx\"}}";
    String respFileTotalInfo ="{\"msgType\":1,\"msgNo\":"+MAGNO_SENDFILE_TOTALINFO+",\"result\":"+RESP_OK+"}";

    String respNoticeFileShareFinish =" {\"msgType\":1,\"msgNo\":"+MAGNO_NOTICE_FINISH+",\"result\":"+RESP_OK+"}";

    int STATE_NO_CONNECT = 1;
    int STATE_RECEIVEBROADCAST = 2;
    int STATE_START_RECEIVEFILE = 4;
    int STATE_START_RECEIVEFILEInfo = 3;
    int CURRENT_STATE = STATE_NO_CONNECT;
    InetAddress conectedAddress;
    int cilentPort;
    int clientReceiveFilePort;
    String path =Environment.getExternalStorageDirectory().getAbsolutePath()+"/TSP/";

    HashMap<String,ServerFileInfo> fileInfoMap = new HashMap<String,ServerFileInfo>();

    ReceiveDataListener receiveDataListener;

    DatagramSocket serversocket ;
    ThreadPoolExecutor executor;
    ArrayBlockingQueue arrayBlockingQueue =   new ArrayBlockingQueue<Runnable>(2);
    public DataShareServer(ReceiveDataListener receiveDataListener){
        this.receiveDataListener = receiveDataListener;
        executor = new ThreadPoolExecutor(2, 2, 30, TimeUnit.SECONDS,arrayBlockingQueue);
        executor.allowCoreThreadTimeOut(true);
    }
    public void stop(){
        isStop = true;
    }
    private Runnable receiveTask = new Runnable() {
        @Override
        public void run() {
            try {
                serversocket = new DatagramSocket(port);


                byte[] buf ;
                DatagramPacket packet ;
                while (!isStop){
                    buf = new byte[MAXLENGTH];
                    packet = new DatagramPacket(buf, buf.length);
                    serversocket.receive(packet);



//                    Utils.loge(" buf.length="+ buf.length);
                    String recvMsg = "";
                    if(packet.getLength()>1000){
                        recvMsg = new String(buf, 0,
                               1000);
                    }else{
                         recvMsg = new String(buf, 0,
                                packet.getLength());
                    }

                    String[] strs = recvMsg.split("&");
                    if(strs.length>1){//接收文件
                        receiveFile(strs[0],buf,packet);
                    }else{// 接收消息
                        recvMsg = Utils.decode(recvMsg);
                        Utils.loge("接到解密后的信息"+recvMsg);
                        receiveMsg(packet, recvMsg);
                    }

                }




            }catch (SocketException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    };
    public void startReceive(){
        executor.execute(receiveTask);
    }
    RandomAccessFile randomAccessFile;
    int K= 0;
    MessageDigest msgDigest = null;
    private void receiveFile(String head, byte[] buf,DatagramPacket packet){
        Utils.loge("接到文件head="+head);
//        String recvMsg = new String(buf, 0,
//                1000);
        int allLength = buf.length;

        String fileHead = head+"&";






//        receiveDataListener.onReceiveFileHead(fileHead);
        int length =fileHead.getBytes().length;


         String decodeHead = Utils.decode(head);
        JSONTokener jsonTokener = new JSONTokener(decodeHead);
        JSONObject json = null;
        try {
            json = (JSONObject) jsonTokener.nextValue();
            int msgType = json.getInt("msgType");
            int msgNo = json.getInt("msgNo");
            long offset = 0L;
            if(msgType==0&&msgNo==MAGNO_SENDFILE){
                String deviceNo =  json.getString("deviceNo");
                String fileAllPath = json.getString("filePath");
                int thisfilesize = json.getInt("size");
                offset = json.getLong("offset");
                byte[] result = new byte[thisfilesize];
                System.arraycopy(buf, length, result,0, thisfilesize);

//                File file = new File(path+deviceNo+"/"+fileAllPath);
                String respFile ="{\"msgType\":1,\"msgNo\":"+MAGNO_SENDFILE+"," +
                        "\"filePath\":\"" +fileAllPath+"\","+
                        "\"result\":"+RESP_OK+"," +
                        "\"msg\":\"ok\"" +
                        "}";
                ServerFileInfo serverFileInfo = fileInfoMap.get(deviceNo+"/"+fileAllPath);
                if(!((offset+thisfilesize)==serverFileInfo.getFileSize())){// 没传完
                    sendMsg(respFile);
                }


//                if (!file.getParentFile().exists()) {
//                    file.getParentFile().mkdirs();
//                }
//
//                if(!file.exists()){
//                    file.createNewFile();
//                }
                K++;

                long preLenth = randomAccessFile.length();
                if(preLenth == offset){// 预防重传
                    msgDigest.update(result);
                }else{
                    return;
                }

                randomAccessFile.seek(offset);
//                Utils.loge(",已经接收的次数：" + K);
//                Utils.loge(",已经接收：offset" + offset);
                randomAccessFile.write(result);

//                Utils.loge(",文件大小：" + randomAccessFile.length());


                if(serverFileInfo!=null){
//                    Utils.loge("文件总大小"+serverFileInfo.getFileSize()+",已经接收："+randomAccessFile.length());
                    if(serverFileInfo.getFileSize() == randomAccessFile.length()){
                        Utils.loge(deviceNo + "/" + fileAllPath + "文件传输完毕");

                        String md5 =  Utils. bufferToHex(msgDigest.digest());
                        if(!serverFileInfo.getMd5().equals(md5)){
                            respFile ="{\"msgType\":1,\"msgNo\":"+MAGNO_SENDFILE+"," +
                                    "\"filePath\":\"" +fileAllPath+"\","+
                                    "\"result\":"+RESP_VALID_ERROR+"," +
                                    "\"msg\":\"md5不通过\"" +
                                    "}";
                            String filePath= path+deviceNo+"/"+fileAllPath;
                            File file = new File(filePath);

                            if(file.exists()){
                                file.delete();
                            }
                        }else{
                            receiveDataListener.onReceiveFileSuccess(serverFileInfo.getFileRelativePath());
                        }
                        sendMsg(respFile);
                        CURRENT_STATE = STATE_START_RECEIVEFILEInfo;
                    }
                }
//                randomAccessFile.close();


                Utils.loge("存储完毕");

            }else{
                CURRENT_STATE = STATE_RECEIVEBROADCAST;
            }
        }catch (JSONException e) {
            e.printStackTrace();
            CURRENT_STATE = STATE_RECEIVEBROADCAST;
        }catch (IOException e) {
            e.printStackTrace();
            CURRENT_STATE = STATE_RECEIVEBROADCAST;
        }


    }
    private void receiveMsg(DatagramPacket packet,String msg){

        JSONTokener jsonTokener = new JSONTokener(msg);
        JSONObject json = null;
        try {
            json = (JSONObject) jsonTokener.nextValue();
            int msgType = json.getInt("msgType");
        }catch (JSONException e) {
            e.printStackTrace();
        }
        try {
            int msgNo = json.getInt("msgNo");
            JSONObject sendJson;
            switch(msgNo){
                case MAGNO_BROADCAST:
                    String version = json.getString("version");
                    String deviceName = json.getString("deviceName");
                    JSONArray pttVer = json.getJSONArray("ptt");
                    int port = json.getInt("port");
                    conectedAddress = packet.getAddress();
                    cilentPort = packet.getPort();
                    if(pttVer.toString().contains(currVer)){// 开启回
                        sendMsg(respBroadcast);

                    }else{
                        sendMsg(respBroadcast);
                    }
                    receiveDataListener.onReceiveBroadCast(msg);
                    break;
                case MAGNO_SENDDEVICENO:
//                    deviceNo = json.getString("deviceNo");
                    sendMsg(respDeviceNo);
                    receiveDataListener.onReceiveDeviceNo(msg);
                    break;
                case MAGNO_GETDATA:
                    sendMsg(respGetData);
                    receiveDataListener.onReceiveDeviceNo(msg);
                    break;
                case MAGNO_SENDFILE_TOTALINFO:
                    respFileTotalInfo ="{\"msgType\":1,\"msgNo\":"+MAGNO_SENDFILE_TOTALINFO+",\"result\":"+RESP_OK+"}";
                    receiveDataListener.onReceiveFileInfo(msg);
                    sendMsg(respFileTotalInfo);

                    break;

                case MAGNO_SENDFILE_INFO:
                    String deviceNo =  json.getString("deviceNo");
                    String fileAllPath = json.getString("filePath");
                    String filemd5 = json.getString("filemd5");
                    long fileSize =  json.getLong("fileSize");
                    ServerFileInfo serverFileInfo = new ServerFileInfo();
                    serverFileInfo.setMd5(filemd5);
                    serverFileInfo.setFileRelativePath(fileAllPath);
                    serverFileInfo.setFileSize(fileSize);
                    fileInfoMap.put(deviceNo + "/" + fileAllPath, serverFileInfo);
//                    sendMsg(respFileInfo);
                    receiveDataListener.onReceiveFileInfo(msg);


                   String filePath= path+deviceNo+"/"+fileAllPath;
                    File file = new File(filePath);
                    long size = 0L;
                    if(file.exists()){
                         size = file.length();
                    }else{
                        if (!file.getParentFile().exists()) {
                            file.getParentFile().mkdirs();
                        }


                        file.createNewFile();

                    }
                    int result = RESP_OK;
                    if(size==fileSize){
                        result = RESP_FILE_FINISH;
                    }
                    String str ="{\"msgType\":1," +
                            "\"msgNo\":"+MAGNO_SENDFILE_INFO+"," +
                            "\"offset\":"+size+"," +
                            "\"result\":"+result+"}";
                    try {
                        if(msgDigest!=null){
                            msgDigest.reset();
                        }
                        msgDigest = MessageDigest.getInstance("MD5");
                    } catch (NoSuchAlgorithmException e) {
                        throw new IllegalStateException(
                                "System doesn't support MD5 algorithm.");
                    }
                    if(size>0){
                        try {
                            Utils.fileMd5(file,msgDigest);
                        }catch (IOException e){
                            e.printStackTrace();
                            return;
                        }

                    }
                    sendMsg(str);

                    if(result == RESP_OK){
                        CURRENT_STATE = STATE_START_RECEIVEFILE;
                    }
                    if(randomAccessFile!=null){
                        randomAccessFile.close();
                    }
                    randomAccessFile  = new RandomAccessFile(path+deviceNo+"/"+fileAllPath, "rwd");
                    break;
                case MAGNO_NOTICE_FINISH:
                    sendMsg(respNoticeFileShareFinish);

                    break;
            }



        } catch (JSONException e) {
            e.printStackTrace();
        }catch (IOException e){
            e.printStackTrace();
        }
    }
    private void sendMsg(String msg) throws IOException{
        msg = Utils.encode(msg);
        byte[] buf = msg.getBytes();
        DatagramPacket mBRDPacket = new DatagramPacket(buf, buf.length,conectedAddress,cilentPort);
        serversocket.send(mBRDPacket);


    }
}
