package com.mxnavi.tspv2.datashare;

import android.os.Environment;

import com.mxnavi.tspv2.datashare.model.ServerFileInfo;
import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;

/**
 * Created by Administrator on 2016/7/28.
 * desc
 */
public class ReceiveFileTask implements Runnable {
    boolean isPause = false;

//    int STATE_START_RECEIVEFILEInfo = 3;
//    int STATE_START_RECEIVEFILE = 4;
//    int CURRENT_STATE = STATE_START_RECEIVEFILEInfo;

    String path = Environment.getExternalStorageDirectory().getAbsolutePath()+"/TSP/";
    HashMap<String,ServerFileInfo> fileInfoMap = new HashMap<String,ServerFileInfo>();

    int receivePort;
    DatagramSocket socket;
    InetAddress conectedAddress;
    SendDataListener sendDataListener;
    public ReceiveFileTask(DatagramSocket receiveSocket,InetAddress conectedAddress,SendDataListener sendDataListener){
        socket = receiveSocket;
        this.conectedAddress = conectedAddress;
        this.sendDataListener = sendDataListener;
    }
    public void setConectedAddress(InetAddress conectedAddress){
        this.conectedAddress = conectedAddress;
    }
    public void run(){
        byte[] buf ;
        DatagramPacket packet ;

        try {
            while (!isPause) {

                buf = new byte[4096];
                packet = new DatagramPacket(buf, buf.length);
                socket.receive(packet);
                receivePort = packet.getPort();
                int length =  packet.getLength();
                Utils.loge("packet.getLength()=" + length);
                receiveMsg(buf,packet);

            }
        }catch (SocketException e) {
            e.printStackTrace();
        } catch (IOException e) {

        }
    }
    public void stop(){
        isPause = true;


        socket.close();
    }

    MessageDigest msgDigest = null;


    private void receiveMsg( byte[] buf,DatagramPacket packet){
        int maxlength = 1024;
        if(packet.getLength() < maxlength){
            maxlength = packet.getLength();
        }
        String recvMsg = new String(buf, 0,
                maxlength);
        String msg = recvMsg.split("\\&")[0];

        JSONTokener jsonTokener = new JSONTokener(recvMsg);
        JSONObject json = null;
        int msgType = 0;
        int msgNo = 0;
        long offset = 0L;
        try {
            json = (JSONObject) jsonTokener.nextValue();
            msgType = json.getInt("msgType");
            msgNo = json.getInt("msgNo");

        }catch (JSONException e) {
            e.printStackTrace();
        }
        if(msgType==0&&msgNo==3){// 接收到文件信息
            String deviceNo = "";
            String fileAllPath = "";
            String filemd5 = "";
            long fileSize = 0;
            try {
                deviceNo =  json.getString("deviceNo");
                fileAllPath = json.getString("fileAllPath");
                filemd5 = json.getString("filemd5");
                fileSize =  json.getLong("fileSize");
            }catch (JSONException e) {
                e.printStackTrace();
                return;
            }

            ServerFileInfo serverFileInfo = new ServerFileInfo();
            serverFileInfo.setMd5(filemd5);
            serverFileInfo.setFileRelativePath(fileAllPath);
            serverFileInfo.setFileSize(fileSize);
            fileInfoMap.put(deviceNo + "/" + fileAllPath, serverFileInfo);
            String respFileInfo =" {\"msgType\":1,\"msgNo\":3}";
//                        sendMsg(respFileInfo);
            byte[] bytes = respFileInfo.getBytes();
            DatagramPacket mBRDPacket = new DatagramPacket(bytes, bytes.length,conectedAddress,receivePort);
            try {
                socket.send(mBRDPacket);
            }catch (IOException e){
                e.printStackTrace();
                return;
            }

//            sendDataListener.onReceiveFileInfo(msg);
            try {
                if(msgDigest!=null){
                    msgDigest.reset();
                }
                msgDigest = MessageDigest.getInstance("MD5");
            } catch (NoSuchAlgorithmException e) {
                    throw new IllegalStateException(
                            "System doesn't support MD5 algorithm.");
            }


            String filePath= path+deviceNo+"/"+fileAllPath;
            File file = new File(filePath);
            long size = 0L;
            if(file.exists()){
                size = file.length();
                if(size>0){
                    try {
                        Utils.fileMd5(file,msgDigest);
                    }catch (IOException e){
                        e.printStackTrace();
                        return;
                    }

                }
            }

            String str ="{\"msgType\":0," +
                        "\"msgNo\":4," +
                        "\"offset\":"+size+"," +
                        "\"result\":1" +
                        "}";
            try {
                sendMsg(str);
            }catch (IOException e){
                e.printStackTrace();
                return;
            }

        }
        if(msgType==0&&msgNo==5){// 接收到文件
            String fileHead = recvMsg.split("\\&")[0]+"&";
            int length =fileHead.getBytes().length;
            String deviceNo = "";
            String fileAllPath = "";
            int thisfilesize = 0;
            try{
                deviceNo =  json.getString("deviceNo");
                fileAllPath = json.getString("fileAllPath");
                thisfilesize = json.getInt("size");
                offset = json.getLong("offset");
            }catch(JSONException e) {
                e.printStackTrace();
                return;
            }
            ServerFileInfo serverFileInfo = fileInfoMap.get(deviceNo+"/"+fileAllPath);
            if(serverFileInfo == null){
                return ;
            }
            byte[] result = new byte[thisfilesize];
            System.arraycopy(buf, length, result, 0, thisfilesize);

            File file = new File(path+deviceNo+"/"+fileAllPath);
            long size = 0L;
            if (!file.getParentFile().exists()) {
                file.getParentFile().mkdirs();
            }

            if(!file.exists()){
                try {
                    file.createNewFile();
                }catch (IOException e){
                    e.printStackTrace();
                    return;
                }

            }
            RandomAccessFile randomAccessFile = null;
            long preLenth = 0L;
            try {
                randomAccessFile = new RandomAccessFile(path + deviceNo + "/" + fileAllPath, "rwd");
                 preLenth = randomAccessFile.length();
                randomAccessFile.seek(offset);

                Utils.loge(",已经接收：offset" + offset);
                randomAccessFile.write(result);
                size = randomAccessFile.length();
            }catch (IOException e){
                e.printStackTrace();
                String respFile ="{\"msgType\":1,\"msgNo\":5," +
                            "\"fileAllPath\":\"" +fileAllPath+"\","+
                            "\"result\":500," +
                            "\"msg\":\"文件读写错误\"" +
                            "}";
                try {
                    sendMsg(respFile);
                }catch (IOException f){
                    f.printStackTrace();

                }
                return;
            }finally {
                try {
                    randomAccessFile.close();
                }catch (IOException f){
                    f.printStackTrace();

                }
            }
//                Utils.loge(",文件大小：" + randomAccessFile.length());
            String respFile ="{\"msgType\":1,\"msgNo\":5," +
                        "\"fileAllPath\":\"" +fileAllPath+"\","+
                        "\"result\":200," +
                        "\"msg\":\"ok\"" +
                        "}";
            if(preLenth == offset){// 预防重传
                msgDigest.update(result);
            }


//                    Utils.loge("文件总大小"+serverFileInfo.getFileSize()+",已经接收："+randomAccessFile.length());
            if(serverFileInfo.getFileSize() == size){
                String fileMd5 = Utils.bufferToHex(msgDigest.digest());
                if(fileMd5.equals(serverFileInfo.getMd5())){
                    Utils.loge(deviceNo+"/"+fileAllPath+"文件传输完毕");
                    fileInfoMap.remove(deviceNo + "/" + fileAllPath);
                }else{//文件MD5校验不通过，删除重新传
                    file.delete();
                    respFile ="{\"msgType\":1,\"msgNo\":5," +
                                   "\"fileAllPath\":\"" +fileAllPath+"\","+
                                   "\"result\":400," +
                                   "\"msg\":\"ok\"" +
                                   "}";
                }
            }
            try {
                sendMsg(respFile);
            }catch (IOException f){
                f.printStackTrace();

            }

        }
    }
    private void sendMsg(String msg) throws IOException{
        byte[] buf = msg.getBytes();
        DatagramPacket mBRDPacket = new DatagramPacket(buf, buf.length,conectedAddress,receivePort);
        socket.send(mBRDPacket);

    }
}
