package com.mxnavi.tspv2.datashare;

import com.mxnavi.tspv2.datashare.model.DeviceInfo;

/**
 * Created by Administrator on 2016/7/22.
 * desc
 */
public interface SendDataListener extends ConnectListener{

    /**
     * 更新发送进度
     * @param hasSendFilePercent 发送进度 百分比,保留两位小数，如50.12，含义为50.12%
     * @param speed 发送速度，单位是 B/s
     */
    public void  updateProcess(float hasSendFilePercent,float speed);
    /**
     * 文件接收端接收文件时出现内部错误，暂停传输
     * @param filePath 接收错误的文件路径
     * @param errorCode 错误码 0-接收端校验不通过，此文件需要重新传输，不停止发送，自动重传；1-接收端出现内部错误，停止发送，2-整个文件夹校验不通过，所有文件都需要重新传,并停止发送；3-文件路径不存在，停止发送；4-读取文件其他IO问题，停止发送
     * @param msg 错误信息
     */
    public void  onSendFileFail(String filePath,int errorCode,String msg);

    /**
     * 传输完成单个文件
     * @param filePath 传输完成的文件路径
     */
    public void  onSendSingleFileFinish(String filePath);

    /**
     * 所有文件发送成功
     */
    public void  onSendAllFileFinish();

    /**
     * 接收者存储空间不足，已经停止传输
     */
    public void  onReceiverNotEnoughMemory();

    /**
     * 已经停止发送文件的线程，停止完才可以再次点击获取车机信息按钮
     */
    public void  onStopSendFile();

}

