package com.mxnavi.tspv2.driving.model;

import java.util.List;

/**
 * Created by Administrator on 2016/5/3.
 * desc
 */
public class PriceItem {
    List<PartPrice> partPrice;
    int distince;
    int stepDistince;
    int stepPrice;
    int beforeWaitingTime;
    int beforeWaitingPrice;
    String desc;

    /**
     * 获取不同时间段基础起步价
     * @return 不同时间段基础起步价
     */
    public List<PartPrice> getPartPrice() {
        return partPrice;
    }

    /**
     * 设置不同时间段基础起步价
     * @param partPrice
     */
    public void setPartPrice(List<PartPrice> partPrice) {
        this.partPrice = partPrice;
    }

    /**
     * 获取基础起步价行驶距离(单位:公里)
     * @return 基础起步价行驶距离(单位:公里)
     */
    public int getDistince() {
        return distince;
    }

    /**
     * 设置基础起步价行驶距离(单位:公里)
     * @param distince
     */
    public void setDistince(int distince) {
        this.distince = distince;
    }

    /**
     * 获取距离计价步长(单位:公里)
     * @return 距离计价步长(单位:公里)
     */
    public int getStepDistince() {
        return stepDistince;
    }

    /**
     * 设置距离计价步长(单位:公里)
     * @param stepDistince
     */
    public void setStepDistince(int stepDistince) {
        this.stepDistince = stepDistince;
    }

    /**
     * 获取变价步长(单位:元)
     * @return 变价步长(单位:元)
     */
    public int getStepPrice() {
        return stepPrice;
    }

    /**
     * 设置变价步长(单位:元)
     * @param stepPrice
     */
    public void setStepPrice(int stepPrice) {
        this.stepPrice = stepPrice;
    }

    /**
     * 获取代驾开始前的等候时长步长（单位：分钟）
     * @return 代驾开始前的等候时长步长（单位：分钟）
     */
    public int getBeforeWaitingTime() {
        return beforeWaitingTime;
    }

    /**
     * 设置代驾开始前的等候时长步长（单位：分钟）
     * @param beforeWaitingTime
     */
    public void setBeforeWaitingTime(int beforeWaitingTime) {
        this.beforeWaitingTime = beforeWaitingTime;
    }

    /**
     * 获取代驾开始前的等候费用步长(单位:元)
     * @return 代驾开始前的等候费用步长(单位:元)
     */
    public int getBeforeWaitingPrice() {
        return beforeWaitingPrice;
    }

    /**
     * 设置代驾开始前的等候费用步长(单位:元)
     * @param beforeWaitingPrice
     */
    public void setBeforeWaitingPrice(int beforeWaitingPrice) {
        this.beforeWaitingPrice = beforeWaitingPrice;
    }

    /**
     * 获取夜间代驾的辅助信息
     * @return 夜间代驾的辅助信息
     */
    public String getDesc() {
        return desc;
    }

    /**
     * 设置夜间代驾的辅助信息
     * @param desc
     */
    public void setDesc(String desc) {
        this.desc = desc;
    }
}
