package com.mxnavi.tspv2.feichuan.client.listener;



/**
 * Created by Administrator on 2016/8/4.
 * desc
 */
public interface SendFileListener {

    /**
     * 扫描到车机
     * @param verMatchResult link com.mxnavi.feichuan.common.Constance.SUCCESS_MATHCH_RESULT,CAR_HIGHER_MATHCH_RESULT,CAR_LOWER_MATHCH_RESULT
     *                     车机和手机端的数据传输功能版本号不匹配，则不能继续使用，请更换SDK版本
     *
     */
    public void  onScannedCar(int verMatchResult);

    /**
     * 扫描车机超时，请检查网络，重试
     */
    public void  onScannCarTimeOut();

    /**
     * 建立TCP连接成功
     */
    public void  onConnectSuccess();

    /**
     * 连接断开
     */
    public void  onDisConnect();

    /**
     * 建立TCP连接超时
     */
    public void onConnectTimeOut();

    /**
     * 更新发送进度
     * @param hasSendFilePercent 发送进度 百分比,保留两位小数，如50.12，含义为50.12%
     * @param speed 发送速度，单位是 B/s
     */
    public void  updateProcess(float hasSendFilePercent, float speed);
    /**
     * 文件接收端接收文件时出现内部错误，暂停传输
     * @param filePath 接收错误的文件路径
     * @param errorCode 错误码 0-接收端校验不通过，此文件需要重新传输，不停止发送，自动重传；1-接收端出现内部错误，停止发送，2-整个文件夹校验不通过，所有文件都需要重新传,并停止发送；3-文件路径不存在，停止发送；4-读取文件其他IO问题，停止发送
     * @param msg 错误信息
     */
    public void  onSendFileFail(String filePath, int errorCode, String msg);

    /**
     * 更新传输文件个数
     * @param totalCount 总文件个数
     * @param hasSendFileCount 已传输完成个数
     */
    public void  updateSendFileNum(int totalCount, int hasSendFileCount);

    /**
     * 所有文件发送成功
     */
    public void  onSendAllFileFinish();

    /**
     * 接收者存储空间不足，已经停止传输
     */
    public void  onReceiverNotEnoughMemory();

//    public void  onStopSendFile();

}
