/*
 * (C) Copyright 2015-2016 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 *     ohun@live.cn (夜色)
 */

package com.mxnavi.tspv2.feichuan.common;


import com.mxnavi.tspv2.utils.Utils;

import java.io.DataOutputStream;
import java.io.IOException;


public final class PacketEncoder {


//    public static Packet makePackage(String msg){
//        Packet packet = new Packet();
//        packet.setType(Constance.STRING_PACKET_BYTE);
//        String encode = Util.encode(msg);
//        try {
//            packet.setBytes(encode.getBytes(Constance.STR_CODE));
//        }catch (IOException e){
//            e.printStackTrace();
//        }
//
//        packet.setBodyLength(packet.getBytes().length);
//        return packet;
//    }
//    public static Packet makePackage(byte[] bytes,int length)throws IOException{
//        Packet packet = new Packet();
//        packet.setType(Constance.BYTE_PACKET_BYTE);
//        packet.setBytes(bytes);
//        packet.setBodyLength(length);
//        return packet;
//    }
//    public static Packet makeHeartbeatPackage()throws IOException{
//        Packet packet = new Packet();
//        packet.setType(Constance.HB_PACKET_BYTE);
//        packet.setBodyLength(0);
//        return packet;
//    }
    public static void sendTcpTextMsg(DataOutputStream out, String msg)throws IOException {
        synchronized (out){
            String encode = Utils.encode(msg);
            byte[] bytes = encode.getBytes(Constance.STR_CODE);
            int totalLen = bytes.length;
            out.writeByte(Constance.STRING_PACKET_BYTE);
            out.writeInt(totalLen);
            out.write(bytes);
            out.flush();
        }


    }
    public static void sendTcpByteMsg(DataOutputStream out, byte[] bytes,int length)throws IOException {
        synchronized (out) {
            out.writeByte(Constance.BYTE_PACKET_BYTE);
            out.writeInt(length);
            out.write(bytes, 0, length);
            out.flush();
        }

    }
    public static void sendTcpHeatbeatMsg(DataOutputStream out)throws IOException {
        synchronized (out){
            out.writeByte(Constance.HB_PACKET_BYTE);
            out.writeInt(0);
            out.flush();
        }


    }
}
