package com.mxnavi.tspv2.feichuan.server;

import android.content.Context;
import android.util.Log;

import com.mxnavi.tspv2.feichuan.common.Constance;
import com.mxnavi.tspv2.feichuan.server.core.TcpServer;
import com.mxnavi.tspv2.feichuan.server.core.UdpServer;

import java.io.IOException;
import java.net.ServerSocket;

/**
 * Created by Administrator on 2017/12/26.
 */

public class ServerManager {

     String TAG = Constance.LOG_TAG;
     ServerRunnable mReceiverServer;
     UdpServer UdpServerRunnable;
     FileReceiveListener mFileReceiveListener;
     int mTcpPort = 0;
     Context mContext;
     private static ServerManager serverManager;
     public static ServerManager getInstance(){
          if(serverManager == null){
               serverManager =new ServerManager();
          }
          return serverManager;
     }
     private ServerManager(){

     }
     public void init(Context applicationContext,FileReceiveListener fileReceiveListener){
          mContext  = applicationContext.getApplicationContext();
          mFileReceiveListener = fileReceiveListener;
          initTcpServer();
          initUdpServer();
     }
     /**
      * 开启文件接收端服务
      */
     private void initTcpServer() {
          mReceiverServer = new ServerRunnable();
          new Thread(mReceiverServer).start();
     }

     /**
      * 开启UDP接收线程
      */
     private void initUdpServer() {
          UdpServerRunnable = new UdpServer("",mContext);
          new Thread(UdpServerRunnable).start();
     }
     public int getTcpPort(){
          return mTcpPort;
     }
     class ServerRunnable implements Runnable{
          @Override
          public void run() {
               ServerSocket serverSocket = null;
               try {
                    serverSocket = new ServerSocket(0);
                    mTcpPort = serverSocket.getLocalPort();
               }catch (IOException e){
                    e.printStackTrace();
                    mTcpPort = 0;

               }
               Log.e(TAG,"mTcpPort="+mTcpPort);
               while (!Thread.currentThread().isInterrupted()){
                    Log.e(TAG,"tcpServer.startReceive");
                    TcpServer tcpServer = new TcpServer(serverSocket,mFileReceiveListener);
                    tcpServer.startReceive();
               }

          }
     }

//     class UdpServerRunnable implements Runnable {
//          @Override
//          public void run() {
//
//          }
//     }

}
