package com.mxnavi.tspv2.flowcontrol.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2018/3/26.
 */

public class EffectiveTime implements Parcelable,Serializable {
    String applicationId;//3
    String comboId;//2
    String simNo;//1
    String applicationName;//4
    String effectiveDate;
    int effectiveLeftDate;
    String freeEffectiveDate;
    int freeLeftDays;

    public EffectiveTime() {
    }


    protected EffectiveTime(Parcel in) {
        applicationId = in.readString();
        comboId = in.readString();
        simNo = in.readString();
        applicationName = in.readString();
        effectiveDate = in.readString();
        effectiveLeftDate = in.readInt();
        freeEffectiveDate = in.readString();
        freeLeftDays = in.readInt();
    }

    public static final Creator<EffectiveTime> CREATOR = new Creator<EffectiveTime>() {
        @Override
        public EffectiveTime createFromParcel(Parcel in) {
            return new EffectiveTime(in);
        }

        @Override
        public EffectiveTime[] newArray(int size) {
            return new EffectiveTime[size];
        }
    };

    /**
     * 获取应用id
     * @return
     */
    public String getApplicationId() {
        return applicationId;
    }

    /**
     * 设置应用id
     * @param applicationId
     */
    public void setApplicationId(String applicationId) {
        this.applicationId = applicationId;
    }

    /**
     * 获取套餐id
     * @return
     */
    public String getComboId() {
        return comboId;
    }

    /**
     * 设置套餐id
     * @param comboId
     */
    public void setComboId(String comboId) {
        this.comboId = comboId;
    }


    /**
     * 获取sim卡号
     * @return
     */
    public String getSimNo() {
        return simNo;
    }

    /**
     * 设置sim卡号
     * @param simNo
     */
    public void setSimNo(String simNo) {
        this.simNo = simNo;
    }

    /**
     * 获取应用名称
     * @return
     */
    public String getApplicationName() {
        return applicationName;
    }

    /**
     * 设置应用名称
     * @param applicationName
     */
    public void setApplicationName(String applicationName) {
        this.applicationName = applicationName;
    }

    /**
     * 获取有效期，是指流量的到期时间
     * @return
     */
    public String getEffectiveDate() {
        return effectiveDate;
    }

    /**
     * 设置有效期，是指流量的到期时间
     * @param effectiveDate
     */
    public void setEffectiveDate(String effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    /**
     * 获取有效期剩余时间>=0在有效期，<0 过期
     * @return
     */
    public int getEffectiveLeftDate() {
        return effectiveLeftDate;
    }

    /**
     * 设置有效期剩余时间>=0在有效期，<0 过期
     * @param effectiveLeftDate
     */
    public void setEffectiveLeftDate(int effectiveLeftDate) {
        this.effectiveLeftDate = effectiveLeftDate;
    }

    /**
     * 获取免流量的有效期（到期时间）
     * @return
     */
    public String getFreeEffectiveDate() {
        return freeEffectiveDate;
    }

    /**
     * 设置免流量的有效期（到期时间）
     * @param freeEffectiveDate
     */
    public void setFreeEffectiveDate(String freeEffectiveDate) {
        this.freeEffectiveDate = freeEffectiveDate;
    }

    /**
     * 获取剩余的免流量时间
     * 0代表截止到今天24:00,1代表还有两天到期，2代表还有三天到期，负数表示超过了免流量有效期
     * 当超过了免流量有效期需要使用effective_date来做有效期
     * @return
     */
    public int getFreeLeftDays() {
        return freeLeftDays;
    }

    /**
     * 设置剩余的免流量时间
     * 0代表截止到今天24:00,1代表还有两天到期，2代表还有三天到期，负数表示超过了免流量有效期
     * 当超过了免流量有效期需要使用effective_date来做有效期
     * @param freeLeftDays
     */
    public void setFreeLeftDays(int freeLeftDays) {
        this.freeLeftDays = freeLeftDays;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(applicationId);
        parcel.writeString(comboId);
        parcel.writeString(simNo);
        parcel.writeString(applicationName);
        parcel.writeString(effectiveDate);
        parcel.writeInt(effectiveLeftDate);
        parcel.writeString(freeEffectiveDate);
        parcel.writeInt(freeLeftDays);
    }
}
