package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class AlbumsQuery implements Parcelable,Serializable {
    String categoryId;
    String tagId;
    int offset;
    int limit;

    public String getCategoryId() {
        return categoryId;
    }

    public AlbumsQuery() {
    }

    protected AlbumsQuery(Parcel in) {
        categoryId = in.readString();
        tagId = in.readString();
        offset = in.readInt();
        limit = in.readInt();
    }


    public static final Creator<AlbumsQuery> CREATOR = new Creator<AlbumsQuery>() {
        @Override
        public AlbumsQuery createFromParcel(Parcel in) {
            return new AlbumsQuery(in);
        }

        @Override
        public AlbumsQuery[] newArray(int size) {
            return new AlbumsQuery[size];
        }
    };


    /**
     * 设置分类id，0表示所有分类的热门专辑
     * @param categoryId
     */
    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    public String getTagId() {
        return tagId;
    }

    /**
     * 设置标签id，不传返回热门专辑
     * @param tagId
     */
    public void setTagId(String tagId) {
        this.tagId = tagId;
    }

    public int getOffset() {
        return offset;
    }

    /**
     * 设置从第几条开始取，默认为1
     * @param offset
     */
    public void setOffset(int offset) {
        this.offset = offset;
    }

    public int getLimit() {
        return limit;
    }

    /**
     * 设置取多少条，默认20条
     * @param limit
     */
    public void setLimit(int limit) {
        this.limit = limit;
    }
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(categoryId);
        dest.writeString(tagId);
        dest.writeInt(offset);
        dest.writeInt(limit);
    }
}
