package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;
import java.util.List;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class MediaResult implements Parcelable,Serializable {
    /**
     * nextLevel:下一级内容
     * allCount:检索总条数
     * albumName:专辑名
     * sounds:专辑的声音列表
     */
    int nextLevel;
    int allCount;
    String albumName;
    List<MediaInfo> sounds;

    public MediaResult() {
    }

    protected MediaResult(Parcel in) {
        nextLevel = in.readInt();
        allCount = in.readInt();
        albumName = in.readString();
        sounds = in.createTypedArrayList(MediaInfo.CREATOR);
    }

    public static final Creator<MediaResult> CREATOR = new Creator<MediaResult>() {
        @Override
        public MediaResult createFromParcel(Parcel in) {
            return new MediaResult(in);
        }

        @Override
        public MediaResult[] newArray(int size) {
            return new MediaResult[size];
        }
    };
    /**
     * 获取下一级内容
     * @return
     */
    public int getNextLevel() {
        return nextLevel;
    }

    public void setNextLevel(int nextLevel) {
        this.nextLevel = nextLevel;
    }

    /**
     * 获取检索总条数
     * @return
     */
    public int getAllCount() {
        return allCount;
    }

    public void setAllCount(int allCount) {
        this.allCount = allCount;
    }

    /**
     * 获取专辑名
     * @return
     */
    public String getAlbumName() {
        return albumName;
    }

    public void setAlbumName(String albumName) {
        this.albumName = albumName;
    }
    /**
     * 获取专辑的声音列表
     * @return
     */
    public List<MediaInfo> getSounds() {
        return sounds;
    }

    public void setSounds(List<MediaInfo> sounds) {
        this.sounds = sounds;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(nextLevel);
        dest.writeInt(allCount);
        dest.writeString(albumName);
        dest.writeTypedList(sounds);
    }
}
