package com.mxnavi.tspv2.fm.model;

import java.util.List;

/**
 * 直播电台详情
 */

public class Radios {
    int id;
    String kind;
    String programName;
    String radioName;
    String radioDesc;
    int scheduleId;
    List<Integer> supportBitrates;
    String rate24AacUrl;
    String rate24TsUrl;
    String rate64AacUrl;
    String rate64TsUrl;
    int radioPlayCount;
    String coverUrlSmall;
    String coverUrlLarge;
    Long createdAt;
    Long updatedAt;

    /**
     * 获取直播电台ID
     * @return
     */
    public int getId() {
        return id;
    }

    /**
     * 设置直播电台ID
     * @param id
     */
    public void setId(int id) {
        this.id = id;
    }


    /**
     * 获取正在直播的节目名称
     * @return
     */
    public String getProgramName() {
        return programName;
    }

    /**
     * 设置正在直播的节目名称
     * @param programName
     */
    public void setProgramName(String programName) {
        this.programName = programName;
    }

    /**
     * 获取电台名称
     * @return
     */
    public String getRadioName() {
        return radioName;
    }

    /**
     * 设置电台名称
     * @param radioName
     */
    public void setRadioName(String radioName) {
        this.radioName = radioName;
    }

    /**
     * 获取电台简介
     * @return
     */
    public String getRadioDesc() {
        return radioDesc;
    }

    /**
     * 设置电台简介
     * @param radioDesc
     */
    public void setRadioDesc(String radioDesc) {
        this.radioDesc = radioDesc;
    }

    /**
     * 获取正在直播的节目时间表ID
     * @return
     */
    public int getScheduleId() {
        return scheduleId;
    }

    /**
     * 设置正在直播的节目时间表ID
     * @param scheduleId
     */
    public void setScheduleId(int scheduleId) {
        this.scheduleId = scheduleId;
    }

    /**
     * 获取支持的码率列表
     * @return
     */
    public List<Integer> getSupportBitrates() {
        return supportBitrates;
    }

    /**
     * 设置支持的码率列表
     * @param supportBitrates
     */
    public void setSupportBitrates(List<Integer> supportBitrates) {
        this.supportBitrates = supportBitrates;
    }

    /**
     * 获取24码率aac格式播放地址
     * @return
     */
    public String getRate24AacUrl() {
        return rate24AacUrl;
    }

    /**
     * 设置24码率aac格式播放地址
     * @param rate24AacUrl
     */
    public void setRate24AacUrl(String rate24AacUrl) {
        this.rate24AacUrl = rate24AacUrl;
    }

    /**
     * 获取24码率ts格式播放地址
     * @return
     */
    public String getRate24TsUrl() {
        return rate24TsUrl;
    }

    /**
     * 设置24码率ts格式播放地址
     * @param rate24TsUrl
     */
    public void setRate24TsUrl(String rate24TsUrl) {
        this.rate24TsUrl = rate24TsUrl;
    }

    /**
     * 获取64码率aac格式播放地址
     * @return
     */
    public String getRate64AacUrl() {
        return rate64AacUrl;
    }

    /**
     * 设置64码率aac格式播放地址
     * @param rate64AacUrl
     */
    public void setRate64AacUrl(String rate64AacUrl) {
        this.rate64AacUrl = rate64AacUrl;
    }

    /**
     * 获取64码率ts格式播放地址
     * @return
     */
    public String getRate64TsUrl() {
        return rate64TsUrl;
    }

    /**
     * 设置64码率ts格式播放地址
     * @param rate64TsUrl
     */
    public void setRate64TsUrl(String rate64TsUrl) {
        this.rate64TsUrl = rate64TsUrl;
    }

    /**
     * 获取电台累计收听次数
     * @return
     */
    public int getRadioPlayCount() {
        return radioPlayCount;
    }

    /**
     * 设置电台累计收听次数
     * @param radioPlayCount
     */
    public void setRadioPlayCount(int radioPlayCount) {
        this.radioPlayCount = radioPlayCount;
    }

    /**
     * 获取电台封面小图url
     * @return
     */
    public String getCoverUrlSmall() {
        return coverUrlSmall;
    }

    /**
     * 设置电台封面小图url
     * @param coverUrlSmall
     */
    public void setCoverUrlSmall(String coverUrlSmall) {
        this.coverUrlSmall = coverUrlSmall;
    }

    /**
     * 获取电台封面大图图url
     * @return
     */
    public String getCoverUrlLarge() {
        return coverUrlLarge;
    }

    /**
     * 设置电台封面大图图url
     * @param coverUrlLarge
     */
    public void setCoverUrlLarge(String coverUrlLarge) {
        this.coverUrlLarge = coverUrlLarge;
    }

    /**
     * 获取电台创建时间，单位为毫秒
     * @return
     */
    public Long getCreatedAt() {
        return createdAt;
    }

    /**
     * 设置电台创建时间，单位为毫秒
     * @param createdAt
     */
    public void setCreatedAt(Long createdAt) {
        this.createdAt = createdAt;
    }

    /**
     * 获取电台更新时间，单位为毫秒
     * @return
     */
    public Long getUpdatedAt() {
        return updatedAt;
    }

    /**
     * 设置电台更新时间，单位为毫秒
     * @param updatedAt
     */
    public void setUpdatedAt(Long updatedAt) {
        this.updatedAt = updatedAt;
    }
}
