package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class TagHotMediaQuery implements Parcelable,Serializable {
    String categoryId;
    String tagId;
    int offset;
    int limit;
    String condition;

    public TagHotMediaQuery() {
    }
    public TagHotMediaQuery(Parcel in) {
        categoryId = in.readString();
        tagId = in.readString();
        offset = in.readInt();
        limit = in.readInt();
        condition = in.readString();
    }
    public static final Creator<TagHotMediaQuery> CREATOR = new Creator<TagHotMediaQuery>() {
        @Override
        public TagHotMediaQuery createFromParcel(Parcel in) {
            return new TagHotMediaQuery(in);
        }

        @Override
        public TagHotMediaQuery[] newArray(int size) {
            return new TagHotMediaQuery[size];
        }
    };
    public String getCategoryId() {
        return categoryId;
    }

    /**
     * 设置分类id，0表示所有分类的热门专辑
     * @param categoryId
     */
    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    public String getTagId() {
        return tagId;
    }

    /**
     * 设置分类标签id，不填则为热门分类
     * @param tagId
     */
    public void setTagId(String tagId) {
        this.tagId = tagId;
    }

    public int getOffset() {
        return offset;
    }

    /**
     * 设置从第几条开始取，默认为1
     * @param offset
     */
    public void setOffset(int offset) {
        this.offset = offset;
    }

    public int getLimit() {
        return limit;
    }

    /**
     * 设置取多少条，默认20条
     * @param limit
     */
    public void setLimit(int limit) {
        this.limit = limit;
    }

    public String getCondition() {
        return condition;
    }

    /**
     * 设置排序方式  recent:按从新到旧排序
     *               favorite:按赞数排列
     *               week:按本周热门排序
     *               daily:按24小时热门排序
     *               建议使用week或者daily，默认为daily
     * @param condition
     */
    public void setCondition(String condition) {
        this.condition = condition;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(categoryId);
        dest.writeString(tagId);
        dest.writeInt(offset);
        dest.writeInt(limit);
        dest.writeString(condition);
    }
}
