package com.mxnavi.tspv2.location.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class LocationItem implements Parcelable {
    LatLng location;
    long locationTime;
    int direction;
    int speed;

    public LocationItem() {
    }

    /**
     * 获取位置的经纬度
     * @return
     */
    public LatLng getLocation() {
        return location;
    }

    /**
     * 设置位置的经纬度
     * @param location
     */
    public void setLocation(LatLng location) {
        this.location = location;
    }

    /**
     * 获取 位置的时间
     * @return
     */
    public long getLocationTime() {
        return locationTime;
    }

    /**
     * 设置 位置的时间
     * @param locationTime
     */
    public void setLocationTime(long locationTime) {
        this.locationTime = locationTime;
    }

    /**
     * 获取 位置的方向 单位：度
     * @return
     */
    public int getDirection() {
        return direction;
    }

    /**
     * 设置 位置的方向 单位：度
     * @param direction
     */
    public void setDirection(int direction) {
        this.direction = direction;
    }

    /**
     * 获取 位置的速度 单位：km/h
     * @return
     */
    public int getSpeed() {
        return speed;
    }

    /**
     * 设置 位置的速度 单位：km/h
     * @param speed
     */
    public void setSpeed(int speed) {
        this.speed = speed;
    }


    protected LocationItem(Parcel in) {
         location = in.readParcelable(LatLng.class.getClassLoader());
         locationTime = in.readLong();
         direction = in.readInt();
         speed = in.readInt();
    }
    public static final Creator<LocationItem> CREATOR = new Creator<LocationItem>() {
        @Override
        public LocationItem createFromParcel(Parcel in) {
            return new LocationItem(in);
        }

        @Override
        public LocationItem[] newArray(int size) {
            return new LocationItem[size];
        }
    };
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeParcelable(location,flags);
        dest.writeLong(locationTime);
        dest.writeInt(direction);
        dest.writeInt(speed);
    }
}
