package com.mxnavi.tspv2.model;

/**
 * Created by lenovo on 2016/5/17.
 */
public class ErrorCode {
    /**
     * 动态加油站
     */
    public enum gasStationErrorEnum {
        SUCCESS(100,"成功"),
        IERR(-100,"内部错误"),
        PARAMETER_MISSING(-101,"参数缺失"),
        INPUT_PARAMETER_ERROR(-102,"输入参数错误"),
        ;

        private Integer errorCode;
        private String description;

        gasStationErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 行车记录
     */
    public enum drivingRecordErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-101,"发送信息失败"),
        ;

        private Integer errorCode;
        private String description;

        drivingRecordErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }


    /**
     * 代驾服务
     */
    public enum drivingServiceErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        NOT_OPEN(-201,"城市未开通代驾"),
        TOKEN_FAILURE(-202,"token失效"),
        CAPTCHA_FREQUENT(-203,"验证码频繁请求"),
        CAPTCHA_ERROR(-204,"验证码不正确"),
        SENDING_ORDER(-205,"有订单正在派单"),
        REPEATED_CANCELLATION(-206,"订单已经取消过一次，重复取消"),
        ;

        private Integer errorCode;
        private String description;

        drivingServiceErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 在线FM
     */
    public enum FmQueryErrorEnum {
        SUCCESS(100,"成功"),
        SERVER_ERROR(-100,"服务器错误"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        ;

        private Integer errorCode;
        private String description;

        FmQueryErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     *位置信息获取
     */
    public enum locationErrorEnum {
        SUCCESS(100,"成功"),
        NO_LOCATION_INFO(201,"没有该用户的位置信息"),
        INTERNAL_ERROR(-100,"内部错误"),
        PARAMETER_MISSING(-101,"参数缺失"),
        INPUT_PARAMETER_ERROR(-102,"输入参数错误"),
        ;

        private Integer errorCode;
        private String description;

        locationErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }


    /**
     * 新闻
     */
    public enum newsQueryErrorEnum {
        SUCCESS(100,"成功"),
        SERVER_ERROR(-100,"服务器错误"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误，参数缺失"),
        ;

        private Integer errorCode;
        private String description;

        newsQueryErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     *OTA升级
     */
    public enum otaUpgradeErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-101,"参数错误"),
        ;

        private Integer errorCode;
        private String description;

        otaUpgradeErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 动态停车场
     */
    public enum parkingLotSearchErrorEnum {
        SUCCESS(100,"成功"),
        ERR_INTERNAL(-100,"内部错误"),
        ERR_INPUT_MISSING(-101,"请求参数缺失"),
        ERR_INPUT_JSON_INVALID(-102,"json格式错误"),
        ERR_SEARCH_NOTFOUND(101,"在指定地点周围没有找到车位信息"),
        ;

        private Integer errorCode;
        private String description;

        parkingLotSearchErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 车辆违章
     */
    public enum peccancyErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        ERR_INPUT_MISSING(-102,"缺失参数,"),
        ERR_TOKEN_INVALID(-104,"token无效"),
        ERR_ENCRYPTION_ERROR(-105,"加密规则不正确"),
        ;

        private Integer errorCode;
        private String description;

        peccancyErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }


    /**
     * 微信发送到车
     */
    public enum sendToCarErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        ;

        private Integer errorCode;
        private String description;

        sendToCarErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 限行检索
     */
    public enum trafficRestrictionSearchErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-101,"参数缺失"),
        INPUT_PARAMETER_FORM_ERROR(-102,"参数格式不正确"),
        ;

        private Integer errorCode;
        private String description;

        trafficRestrictionSearchErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }


    /**
     * 用户管理
     */
    public enum userErrorEnum {
        SUCCESS(100,"成功"),
//        MESSAGE_SERVER_EXCEPTION(-100,"短信服务器异常"),
//        INPUT_PARAMETER_MISSING(-101,"参数缺失"),
//        INPUT_PARAMETER_ERROR(-102,"参数错误"),
//        MESSAGE_EXCEED_LIMIT(-103,"短信发送次数超过上限"),
//        SESSION_EXPIRED(-999,"表示session过期"),
//        IP_OVER_LIMITING_FREQUENCY(-998,"表示ip访问超过接口限制频率"),
//        USER_ID_DIFFERENT(-997,"表示参数user_id 与登陆的user_id 不同"),
//        CONFIGURATION_ERROR(-996,"配置文件有问题，请S、A、B级接口必须配置访问频率"),
//        SECURITY_LEVEL_NO_CONFIG(-995,"安全等级没有配置，请查看配置文件"),
//        NO_PARAMETER_USER_ID(-994,"没有参数user_id"),
        USER_NO_EXISTENT(10000,"用户不存在"),
        USER_ALREADY_EXISTS(10001,"用户以存在"),
        USERID_MISMATCHING_LOGIN(10002,"用户ID与登录不匹配"),
        CREATE_PATH_FAIL(10003,"用户创建头像路径失败"),
        username_ALREADY_EXISTS(10004,"用户名已存在"),
        NOT_LOGGED_IN(20000,"未登录"),
        USERNAME_OR_PASSWORD_ERROR(20001,"用户名或密码错误"),
        NO_SET_PASSWORD(20002,"密码未初始化，请用其他方式登录"),
        OVERDUE_REFRESHTOKEN(20003,"refreshToken 失效"),
        PHONENUM_FORMAT_ERROR(30000,"电话格式校验错误"),
        MASSAGE_TYPE_NO_EXIST(30001,"不支持的短信类型"),
        IDENTIFYING_CODE_ERROR(30002,"短信验证码校验错误"),
        OVERDUE_MASSAGE_SESSION(30003,"短信验证码session超期"),
        BINDED_PHONENUM(30004,"电话已被绑定"),
        BINDED_PHONENUM_NO_REGISTER(30005,"电话未注册"),
        OVERDUE_MAIL_SESSION(30006,"Mail验证session超期"),
        THIRD_PLATFORM_APPID_ERROR(40000,"第三方平台appId错误"),
        WECHAT_USER_NO_EXIST(40002,"微信用户不存在"),
        USER_NO_CONCERN(40003,"用户未关注"),
        BINDED_PLATE_NUMBER(40100,"车牌号已经与该用户绑定了"),
        BINDED_PLATE_NO_EXIST(40101,"车牌号码不存在"),
        SERVER_ERR_INTERNAL(50000,"Server 内部错误"),
        ;

        private Integer errorCode;
        private String description;

        userErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 天气服务
     */
    public enum weatherSearchErrorEnum {
        SUCCESS(100,"成功"),
        SERVER_ERROR(-100,"服务器错误"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        DISABLE_GPS(-200,"无效gps经纬度"),
        SUCCESS_EMPTY_DATA(101,"成功，空数据"),
        ;

        private Integer errorCode;
        private String description;

        weatherSearchErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 权限管理
     */
    public enum authServiceErrorEnum {
        SUCCESS(100,"成功"),
        FAIL(-100,"失败"),
        INPUT_PARAMETER_ERROR(-200,"参数错误"),
        ;

        private Integer errorCode;
        private String description;

        authServiceErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * NDS升级
     */
    public enum ndsUpdateGradeErrorEnum {
        SUCCESS(100,"成功"),
        ERR_INTERNAL(-100,"内部错误"),
        INPUT_PARAMETER_MISSING(-101,"参数缺失"),
        INPUT_PARAMETER_ERROR(-102,"输入参数错误"),
        ;
        private Integer errorCode;
        private String description;
        ndsUpdateGradeErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 设备绑定
     */
    public enum serviceIntegratorErrorEnum {
        SUCCESS(100,"成功"),
        INPUT_PARAMETER_MISSING(-101,"参数为空"),
        INPUT_PARAMETER_ERROR(-102,"参数无效"),
        DEVICENO_NON_EXISTENT(-103,"车机号不存在"),
        EXIST_BINDING_RELATIONSHIP(-125,"车机和用户存在绑定关系"),
        PRODUCTID_NON_EXISTENT(-126,"产品系列不存在"),
        HTTP_COMMUNICATION_EXCEPTION(-201,"Http通信异常"),
        PUBLIC_NUMBER_NONSUPPORT_PRODUCTID(-304,"公众号不支持产品系列"),
        PUBLIC_NUMBER_mismatching_PRODUCTID(-305,"公众号与产品系列不匹配"),
        MULTIPUBLIC_NUMBER_SUPPORT_PRODUCTID(-306,"多个公众号支持该产品系列"),
        ;
        private Integer errorCode;
        private String description;
        serviceIntegratorErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 搜索
     */
    public enum searchServiceErrorEnum {
        SUCCESS(100,"成功"),
        SERVER_ERROR(-100,"服务器错误"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        NO_FIND_DATA(-102,"输入信息未找到对应的行政区数据"),
        ;
        private Integer errorCode;
        private String description;
        searchServiceErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

    /**
     * 行政区列表更新
     */
    public enum placeServiceErrorEnum {
        SUCCESS(100,"成功"),
        SERVER_ERROR(-100,"服务器错误"),
        INPUT_PARAMETER_ERROR(-101,"输入参数错误"),
        NO_FIND_DATA(101,"成功，空数据"),//大的区域code（例如省code）没有对应天气数据，请输入该code下细分的区域code
        ;
        private Integer errorCode;
        private String description;
        placeServiceErrorEnum(int errorCode, String description) {
            this.errorCode = errorCode;
            this.description = description;
        }

        public Integer getErrorCode() {
            return errorCode;
        }

        public void setErrorCode(Integer errorCode) {
            this.errorCode = errorCode;
        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }
    }

}
