package com.mxnavi.tspv2.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/3/17.
 */
public class TspCity implements Parcelable ,Serializable {
    /**
     * 省份
     */
    String provName;
    /**
     * 城市
     */
    String cityName;
    /**
     * 地区
     */
    String distName;
    /**
     * 当前城市代码
     */
    String currentCityCode;

    private static final long serialVersionUID = 1L;

    public TspCity() {
    }

    public TspCity(String provName, String cityName, String distName, String currentCityCode) {
        this.provName = provName;
        this.cityName = cityName;
        this.distName = distName;
        this.currentCityCode = currentCityCode;
    }

    protected TspCity(Parcel in) {
        provName = in.readString();
        cityName = in.readString();
        distName = in.readString();
        currentCityCode = in.readString();
    }

    public static final Creator<TspCity> CREATOR = new Creator<TspCity>() {
        @Override
        public TspCity createFromParcel(Parcel in) {
            return new TspCity(in);
        }

        @Override
        public TspCity[] newArray(int size) {
            return new TspCity[size];
        }
    };

    /**
     * 获取省份名称
     *
     * @return
     */
    public String getProvName() {
        return provName;
    }

    /**
     * 设置省份名称
     *
     * @param provName
     */
    public void setProvName(String provName) {
        this.provName = provName;
    }

    /**
     * 获取城市名称
     *
     * @return
     */
    public String getCityName() {
        return cityName;
    }

    /**
     * 设置城市名称
     *
     * @param cityName
     */
    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    /**
     * 获取地区名称
     *
     * @return
     */
    public String getDistName() {
        return distName;
    }

    /**
     * 设置地区名称
     *
     * @param distName
     */
    public void setDistName(String distName) {
        this.distName = distName;
    }

    /**
     * 获取当前城市代码
     *
     * @return
     */
    public String getCurrentCityCode() {
        return currentCityCode;
    }

    /**
     * 设置当前城市代码
     *
     * @param currentCityCode
     */
    public void setCurrentCityCode(String currentCityCode) {
        this.currentCityCode = currentCityCode;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(provName);
        dest.writeString(cityName);
        dest.writeString(distName);
        dest.writeString(currentCityCode);
    }
}
