package com.mxnavi.tspv2.news.model;

import java.util.List;

/**
 * Created by Administrator on 2016/4/27.
 * 新闻列表查询条件类
 */
public class NewsListQuery {
    List<Integer> channelIds;
    int infoKind;
    int offset;
    int limit;

    /**
     * 获取新闻频道id
     * @return
     */
    public List<Integer> getChannelIds() {
        return channelIds;
    }

    /**
     * 设置新闻频道id
     * @param channelIds
     */
    public void setChannelIds(List<Integer> channelIds) {
        this.channelIds = channelIds;
    }

    /**
     * 获取获取的新闻内容类型 1-只获取新闻基本信息，如id、标题、发布时间、作者、来源等；
     * 2-只获取新闻摘要，3-获取新闻基本信息和新闻摘要：4-只获取新闻内容，5-获取新闻内容和新闻基本信息；
     * 6-获取新闻内容和新闻摘要；7-获取新闻基本信息、新闻摘要和新闻内容
     * @return
     */
    public int getInfoKind() {
        return infoKind;
    }

    /**
     * 设置获取的新闻内容类型 1-只获取新闻基本信息，如id、标题、发布时间、作者、来源等；
     * 2-只获取新闻摘要，3-获取新闻基本信息和新闻摘要：4-只获取新闻内容，5-获取新闻内容和新闻基本信息；
     * 6-获取新闻内容和新闻摘要；7-获取新闻基本信息、新闻摘要和新闻内容
     * @param infoKind
     */
    public void setInfoKind(int infoKind) {
        this.infoKind = infoKind;
    }

    /**
     * 获取从第几条开始取，默认为1(当取多个频道时，必须为1)
     * @return
     */
    public int getOffset() {
        return offset;
    }

    /**
     * 设置从第几条开始取，默认为1(当取多个频道时，必须为1)
     * @param offset
     */
    public void setOffset(int offset) {
        this.offset = offset;
    }

    /**
     * 获取取多少条，默认20条(当取多个频道时，表示每个频道取limit条)
     * @return
     */
    public int getLimit() {
        return limit;
    }

    /**
     * 设置取多少条，默认20条(当取多个频道时，表示每个频道取limit条)
     * @param limit
     */
    public void setLimit(int limit) {
        this.limit = limit;
    }
}
