package com.mxnavi.tspv2.notification.model;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Created by Administrator on 2016/4/15.
 * desc
 */
public class MessageInfo implements Parcelable {
    String weChatOpenId;
    String msgType;
    String msgSubtype;
    String msgId;

    public MessageInfo() {
    }

    protected MessageInfo(Parcel in) {
        weChatOpenId = in.readString();
        msgType = in.readString();
        msgSubtype = in.readString();
        msgId = in.readString();
    }

    public static final Creator<MessageInfo> CREATOR = new Creator<MessageInfo>() {
        @Override
        public MessageInfo createFromParcel(Parcel in) {
            return new MessageInfo(in);
        }

        @Override
        public MessageInfo[] newArray(int size) {
            return new MessageInfo[size];
        }
    };

    /**
     * 获取用户的微信账号ID
     * @return
     */
    public String getWeChatOpenId() {
        return weChatOpenId;
    }

    /**
     * 设置 用户的微信账号ID
     * @param weChatOpenId
     */
    public void setWeChatOpenId(String weChatOpenId) {
        this.weChatOpenId = weChatOpenId;
    }

    /**
     * 获取 消息类型:”wecar_app” 事
     * @return
     */
    public String getMsgType() {
        return msgType;
    }

    /**
     * 设置 消息类型:”wecar_app” 事
     * @param msgType
     */
    public void setMsgType(String msgType) {
        this.msgType = msgType;
    }

    /**
     * 获取 “poi”，目前只有POI数据与“music”。
     服务器只会下发”POI”的消息“music”
     等其他消息服务器会主动忽略。公众号固定poi
     * @return
     */
    public String getMsgSubtype() {
        return msgSubtype;
    }

    /**
     * 设置 “poi”，目前只有POI数据与“music”。
     服务器只会下发”POI”的消息“music”
     等其他消息服务器会主动忽略。公众号固定poi
     * @param msgSubtype
     */
    public void setMsgSubtype(String msgSubtype) {
        this.msgSubtype = msgSubtype;
    }

    /**
     * 获取 消息ID，消息ID唯一(美行ID)
     * @return
     */
    public String getMsgId() {
        return msgId;
    }

    /**
     * 设置 消息ID，消息ID唯一(美行ID)
     * @param msgId
     */
    public void setMsgId(String msgId) {
        this.msgId = msgId;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(weChatOpenId);
        dest.writeString(msgType);
        dest.writeString(msgSubtype);
        dest.writeString(msgId);
    }
}
