package com.mxnavi.tspv2.notification.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by Administrator on 2016/4/15.
 * desc
 */
public class MessagePoiContent implements Parcelable {
    String source;
    String name;
    String address;
    LatLng latLng;
    LatLng maxLatLng;
    String phone;
    String msg;

    WeChatUserInfo weChatUserInfo;

    String precision;
    int similar;
    long subscribeTime;
    String openId;
    String groupId;

    public MessagePoiContent() {
    }

    protected MessagePoiContent(Parcel in) {
        source = in.readString();
        name = in.readString();
        address = in.readString();
        latLng = in.readParcelable(LatLng.class.getClassLoader());
        maxLatLng = in.readParcelable(LatLng.class.getClassLoader());
        phone = in.readString();
        msg = in.readString();
        weChatUserInfo = in.readParcelable(WeChatUserInfo.class.getClassLoader());
        precision = in.readString();
        similar = in.readInt();
        subscribeTime = in.readLong();
        openId = in.readString();
        groupId = in.readString();
    }

    public static final Creator<MessagePoiContent> CREATOR = new Creator<MessagePoiContent>() {
        @Override
        public MessagePoiContent createFromParcel(Parcel in) {
            return new MessagePoiContent(in);
        }

        @Override
        public MessagePoiContent[] newArray(int size) {
            return new MessagePoiContent[size];
        }
    };

    /**
     * 获取 位置来源比如微信、大众点评(未取得结果时“”)
     * @return
     */
    public String getSource() {
        return source;
    }

    /**
     * 设置 位置来源比如微信、大众点评(未取得结果时“”)
     * @param source
     */
    public void setSource(String source) {
        this.source = source;
    }

    /**
     * 获取  POI 名称(未取得结果时“”)
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * 获取 POI 名称(未取得结果时“”)
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * 获取 POI 地址(未取得结果时“”)
     * @return
     */
    public String getAddress() {
        return address;
    }

    /**
     * 获取 POI 地址(未取得结果时“”)
     * @param address
     */
    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * 获取 经纬度（委屈的结果时“0”）
     * @return
     */
    public LatLng getLatLng() {
        return latLng;
    }

    /**
     *设置 经纬度（委屈的结果时“0”）
     * @param latLng
     */
    public void setLatLng(LatLng latLng) {
        this.latLng = latLng;
    }

    /**
     * 获取 腾讯返回经纬度对应美行的经纬度（对应不上该字段为0）
     * @return
     */
    public LatLng getMaxLatLng() {
        return maxLatLng;
    }

    /**
     * 设置 腾讯返回经纬度对应美行的经纬度（对应不上该字段为0）
     * @param maxLatLng
     */
    public void setMaxLatLng(LatLng maxLatLng) {
        this.maxLatLng = maxLatLng;
    }

    /**
     * 获取 POI 电话(未取得结果时“”)
     * @return
     */
    public String getPhone() {
        return phone;
    }

    /**
     * 设置  POI 电话(未取得结果时“”)
     * @param phone
     */
    public void setPhone(String phone) {
        this.phone = phone;
    }

    /**
     * 获取信息描述
     * @return
     */
    public String getMsg() {
        return msg;
    }

    /**
     * 设置信息描述
     * @param msg
     */
    public void setMsg(String msg) {
        this.msg = msg;
    }

    /**
     * 获取微信用户信息
     * @return
     */
    public WeChatUserInfo getWeChatUserInfo() {
        return weChatUserInfo;
    }

    /**
     * 设置微信用户信息
     * @param weChatUserInfo
     */
    public void setWeChatUserInfo(WeChatUserInfo weChatUserInfo) {
        this.weChatUserInfo = weChatUserInfo;
    }

    /**
     * 获取地图级别，可以忽略。(未取得结果时“”)
     * @return
     */
    public String getPrecision() {
        return precision;
    }

    /**
     * 设置 地图级别，可以忽略。(未取得结果时“”)
     * @param precision
     */
    public void setPrecision(String precision) {
        this.precision = precision;
    }

    /**
     * 获取 相似度(对应不上时0)
     * @return
     */
    public int getSimilar() {
        return similar;
    }

    /**
     * 设置 相似度(对应不上时0)
     * @param similar
     */
    public void setSimilar(int similar) {
        this.similar = similar;
    }

    /**
     * 获取 创建设时间(未取得结果时不显示)
     * @return
     */
    public long getSubscribeTime() {
        return subscribeTime;
    }

    /**
     * 设置 创建设时间(未取得结果时不显示)
     * @param subscribeTime
     */
    public void setSubscribeTime(long subscribeTime) {
        this.subscribeTime = subscribeTime;
    }

    /**
     * 获取 微信ID
     * @return
     */
    public String getOpenId() {
        return openId;
    }

    /**
     * 设置 微信ID
     * @param openId
     */
    public void setOpenId(String openId) {
        this.openId = openId;
    }

    /**
     * (未取得结果时不显示)
     * @return
     */
    public String getGroupId() {
        return groupId;
    }

    /**
     * (未取得结果时不显示)
     * @param groupId
     */
    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(source);
        dest.writeString(name);
        dest.writeString(address);
        dest.writeParcelable(latLng, flags);
        dest.writeParcelable(maxLatLng, flags);
        dest.writeString(phone);
        dest.writeString(msg);
        dest.writeParcelable(weChatUserInfo, flags);
        dest.writeString(precision);
        dest.writeInt(similar);
        dest.writeLong(subscribeTime);
        dest.writeString(openId);
        dest.writeString(groupId);
    }
}
