package com.mxnavi.tspv2.notification.model;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Created by Administrator on 2016/4/15.
 * desc
 */
public class WeChatUserInfo implements Parcelable {
    String nickNname;
    int sex;
    String city;
    String region;
    String country;
    String province;
    String language;
    String headmgurl;

    public WeChatUserInfo() {
    }

    protected WeChatUserInfo(Parcel in) {
        nickNname = in.readString();
        sex = in.readInt();
        city = in.readString();
        region = in.readString();
        country = in.readString();
        province = in.readString();
        language = in.readString();
        headmgurl = in.readString();
    }

    public static final Creator<WeChatUserInfo> CREATOR = new Creator<WeChatUserInfo>() {
        @Override
        public WeChatUserInfo createFromParcel(Parcel in) {
            return new WeChatUserInfo(in);
        }

        @Override
        public WeChatUserInfo[] newArray(int size) {
            return new WeChatUserInfo[size];
        }
    };

    /**
     * 获取用户昵称
     * @return
     */
    public String getNickNname() {
        return nickNname;
    }

    /**
     * 设置用户昵称
     * @param nickNname
     */
    public void setNickNname(String nickNname) {
        this.nickNname = nickNname;
    }

    /**
     * 获取用户头像，最后一个数值代表正方
     形头像大小（有0、46、64、96、
     132 数值可选，0 代表640*640
     正方形头像），用户没有头像时该
     项为空。若用户更换头像，原有头
     像URL 将失效。(未取得结果时“”)
     * @return
     */
    public String getHeadmgurl() {
        return headmgurl;
    }

    /**
     * 设置  用户头像，最后一个数值代表正方
     形头像大小（有0、46、64、96、
     132 数值可选，0 代表640*640
     正方形头像），用户没有头像时该
     项为空。若用户更换头像，原有头
     像URL 将失效。(未取得结果时“”)
     * @param headmgurl
     */
    public void setHeadmgurl(String headmgurl) {
        this.headmgurl = headmgurl;
    }

    /**
     * 获取性别 0 未知 1 男2 女(未取得结果时“0”)
     * @return
     */
    public int getSex() {
        return sex;
    }

    /**
     * 设置 性别 0 未知 1 男2 女(未取得结果时“0”)
     * @param sex
     */
    public void  setSex(int sex) {
        this.sex = sex;
    }

    /**
     * 获取微信账号中用户设定的城市，不会根据用户所在位置变化而变化(未取得结果时“”)
     * @return
     */
    public String getCity() {
        return city;
    }

    /**
     *  设置 微信账号中用户设定的城市，不会根据用户所在位置变化而变化(未取得结果时“”)
     * @param city
     */
    public void setCity(String city) {
        this.city = city;
    }

    /**
     * 获取用户所在的区
     * @return
     */
    public String getRegion() {
        return region;
    }

    /**
     * 设置用户所在的区
     * @param region
     */
    public void setRegion(String region) {
        this.region = region;
    }

    /**
     * 获取用户所在国家
     * @return
     */
    public String getCountry() {
        return country;
    }

    /**
     * 设置 用户所在国家
     * @param country
     */
    public void setCountry(String country) {
        this.country = country;
    }

    /**
     * 获取用户所在省
     * @return
     */
    public String getProvince() {
        return province;
    }

    /**
     * 设置用户所在省
     * @param province
     */
    public void setProvince(String province) {
        this.province = province;
    }

    /**
     * 获取用户的语言如：zh_CN
     * @return
     */
    public String getLanguage() {
        return language;
    }

    /**
     * 设置 用户的语言如：zh_CN
     * @param language
     */
    public void setLanguage(String language) {
        this.language = language;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(nickNname);
        dest.writeInt(sex);
        dest.writeString(city);
        dest.writeString(region);
        dest.writeString(country);
        dest.writeString(province);
        dest.writeString(language);
        dest.writeString(headmgurl);
    }
}
