package com.mxnavi.tspv2.peccancy;

import com.google.gson.Gson;
import com.mxnavi.tspv2.core.BaseTsp;
import com.mxnavi.tspv2.core.Constants;
import com.mxnavi.tspv2.core.MessageBuilder;
import com.mxnavi.tspv2.core.PrioritizedRequestMessage;
import com.mxnavi.tspv2.core.RequestDispathUtil;
import com.mxnavi.tspv2.core.common.CallBackListener;
import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.model.LatLng;
import com.mxnavi.tspv2.model.TspDateTime;
import com.mxnavi.tspv2.peccancy.model.CarViolationInfo;
import com.mxnavi.tspv2.peccancy.model.CarViolationResult;
import com.mxnavi.tspv2.peccancy.model.CarViolationResultData;
import com.mxnavi.tspv2.peccancy.model.LocAdminCodeResult;
import com.mxnavi.tspv2.peccancy.model.PeccancyInfo;
import com.mxnavi.tspv2.peccancy.model.PeccancyItem;
import com.mxnavi.tspv2.core.Config;
import com.mxnavi.tspv2.peccancy.model.UnBindingMyLoveCarRequest;
import com.mxnavi.tspv2.peccancy.model.UpdateMyCarInfoRequest;
import com.mxnavi.tspv2.utils.Utils;
import com.mxnavi.tspv2.peccancy.model.MyLoveCarInfo;
import com.mxnavi.tspv2.peccancy.model.PeccancyCarInfo;
import com.mxnavi.tspv2.peccancy.model.PeccancyByLonLatQuery;
import com.mxnavi.tspv2.peccancy.model.PeccancyResult;

import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2016/4/22.
 * 车辆违章
 */
public class Peccancy extends BaseTsp {
    String mMerchantKey ="12345678";
    String mToken = "111111";
//    String user_id = "12345";
    private static int product_id = Config.CUSTOMER_KEY;
    // 请求服务类型为违章查询
     final int thisServiceType = Config.MxNGTPServiceType.VIOLATION.getServiceType();
    //  违章查询的ServiceData协议版本
     final int serviceDataVer = Config.MxNGTPServiceType.VIOLATION.getServiceVer();
    // 请求服务类型为违章查询
    final int VIOLATION_NEW_ServiceType = Config.MxNGTPServiceType.VIOLATION_NEW.getServiceType();
    //  违章查询的ServiceData协议版本
    final int VIOLATION_NEW_serviceDataVer = Config.MxNGTPServiceType.VIOLATION_NEW.getServiceVer();

    // 请求服务类型为用户管理
    final int USER_ServiceType = Config.MxNGTPServiceType.MX_USER_MANAGE.getServiceType();
    //  用户管理的ServiceData协议版本
    final int USER_ServiceDataVer =Config.MxNGTPServiceType.MX_USER_MANAGE.getServiceVer();

    // 注册此对象为违章查询信息接收类

    private Map<Integer, Integer> listenertypeHashMap = new HashMap<Integer, Integer>();
    final int GETCVDETAILFROMLONLAT = 1;//通过经纬度查询违章信息
    final int GETCVDETAILJQFROMLONLAT = 2;//通过经纬度查询违章信息（需要鉴权)
    final int GETREGIONMAXVER = 3;//查询行政区划列表最新版本号
    final int GETCARREGIONDATA = 4;//查询行政区划列表
    final int GETLOCADMINCODE = 5;//根据经纬度查询行政区编码
    final int GETMYLOVECARLIST = 7;//获取我的爱车信息
    final int BINGMYLOVECAR = 8;//绑定我的爱车信息
    final int UPDATAMYLOVECAR = 9;//修改我的爱车信息
    final int UNBINGMYLOVECAR = 10;//解绑我的爱车信息
    final int GETPECCANCTCARLIST = 11;//获取违章车辆列表
    final int ADDPECCANCTCAR = 12;//添加违章车辆
    final int UPDATAPECCANCTCAR = 13;//修改违章车辆
    final int DELETEPECCANCTCAR = 14;//删除违章车辆
    final int QUERYCARVIOLATION = 15;//获取违章列表


    public Peccancy(String token, String merchantKey){
        mToken = Utils.converNullToEmpty(token);
        mMerchantKey = Utils.converNullToEmpty(merchantKey);
    }
    public Peccancy(){

    }

    /**
     * 通过经纬度查询违章信息
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @return
     */
    public int getCvDetailFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos, TspDateTime startTime, TspDateTime endTime){
        return getCvDetailFromLonAndLat(peccancyCarInfos,startTime,endTime,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 通过经纬度查询违章信息
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getCvDetailFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos,TspDateTime startTime,TspDateTime endTime,int timeOutSecs){
        return getCvDetailFromLonAndLat(peccancyCarInfos,startTime,endTime,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过经纬度查询违章信息
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int getCvDetailFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos,TspDateTime startTime,TspDateTime endTime,int timeOutSecs, int priorityLevel){
        if( peccancyCarInfos== null){
            if (mOnGetCvDetailFromLonAndLatListener != null) {
                mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetCvDetailFromLonAndLat";
        JSONObject param;
        JSONArray paramarray = new JSONArray();
        try{
           int size = peccancyCarInfos.size();
            for(int i =0;i<size; i++){
                PeccancyByLonLatQuery violationByLonLatQuery = peccancyCarInfos.get(i);
                if(violationByLonLatQuery==null|| violationByLonLatQuery.getLatLngList()== null||violationByLonLatQuery.getCarPlateNo()==null||violationByLonLatQuery.getCarKind()==null|| violationByLonLatQuery.getEngineNo()==null){
                    if (mOnGetCvDetailFromLonAndLatListener != null) {
                        mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                    return 0;
                }
                param = new JSONObject();
                StringBuffer lon = new StringBuffer();
                StringBuffer lat = new StringBuffer();
                List<LatLng> latLngList = violationByLonLatQuery.getLatLngList();
                for (int j=0;j<latLngList.size();j++){
                    LatLng latLng = latLngList.get(j);
                    if(j == latLngList.size()-1){
                        lon.append(Utils.converDoubleCoordinate2MX(latLng.getLongitude()));
                        lat.append(Utils.converDoubleCoordinate2MX(latLng.getLatitude()));
                    }else {
                        lon.append(Utils.converDoubleCoordinate2MX(latLng.getLongitude())).append(",");
                        lat.append(Utils.converDoubleCoordinate2MX(latLng.getLatitude())).append(",");
                    }
                }
                param.put("lon",lon.toString());
                param.put("lat",lat.toString());
                param.put("car_plate_no", violationByLonLatQuery.getCarPlateNo());
                param.put("car_kind", violationByLonLatQuery.getCarKind());
                param.put("engine_no", violationByLonLatQuery.getEngineNo());
                param.put("class_no",Utils.converNullToEmpty( violationByLonLatQuery.getClassNo()));
                param.put("regist_no", Utils.converNullToEmpty(violationByLonLatQuery.getRegistNo()));
                paramarray.put(param);
            }
            HashMap<String, Object> params = new HashMap<String, Object>();
            params.put("product_id", product_id);
            params.put("param", paramarray);
            if(startTime !=null&&startTime.getDate()!=null )
            {
                params.put("start_time", startTime.toString());
            }
            if(endTime !=null&&endTime.getDate()!=null  ){
                params.put("end_time", endTime.toString());
            }
            String requestData = Utils.makeUrl(url, params);
            MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
            PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
            requestMessage.timeOutSeconds = timeOutSecs;
            requestMessage.priority = priorityLevel;
            // 添加对应关系
            addCallbackMap(eventId, GETCVDETAILFROMLONLAT);
            RequestDispathUtil.submitRequest(requestMessage);
        }catch (Exception e) {
            e.printStackTrace();
        }

        return eventId;
    }

    /**
     * 通过经纬度查询违章信息（需要鉴权)
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @return
     */
    public int getCvDetailJQFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos, TspDateTime startTime, TspDateTime endTime){
        return getCvDetailJQFromLonAndLat(peccancyCarInfos,startTime,endTime,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 通过经纬度查询违章信息（需要鉴权)
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getCvDetailJQFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos,TspDateTime startTime,TspDateTime endTime,int timeOutSecs){
        return getCvDetailJQFromLonAndLat(peccancyCarInfos,startTime,endTime,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过经纬度查询违章信息（需要鉴权)
     * @param peccancyCarInfos 车辆信息列表
     * @param startTime 查询违章记录的开始时间
     * @param endTime 查询违章记录的结束时间
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int getCvDetailJQFromLonAndLat(List<PeccancyByLonLatQuery> peccancyCarInfos,TspDateTime startTime,TspDateTime endTime,int timeOutSecs, int priorityLevel){
        if( peccancyCarInfos== null){
            if (mOnGetCvDetailFromLonAndLatListener != null) {
                mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetCvDetailJQFromLonAndLat";
        JSONObject param;
        JSONArray paramarray = new JSONArray();
        try{
            int size = peccancyCarInfos.size();
            for(int i =0;i<size; i++){
                PeccancyByLonLatQuery violationByLonLatQuery = peccancyCarInfos.get(i);
                if(violationByLonLatQuery==null|| violationByLonLatQuery.getLatLngList()== null||violationByLonLatQuery.getCarPlateNo()==null||violationByLonLatQuery.getCarKind()==null|| violationByLonLatQuery.getEngineNo()==null){
                    if (mOnGetCvDetailFromLonAndLatListener != null) {
                        mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                    return 0;
                }
                param = new JSONObject();
                StringBuffer lon = new StringBuffer();
                StringBuffer lat = new StringBuffer();
                List<LatLng> latLngList = violationByLonLatQuery.getLatLngList();
                for (int j=0;j<latLngList.size();j++){
                    LatLng latLng = latLngList.get(j);
                    if(j == latLngList.size()-1){
                        lon.append(Utils.converDoubleCoordinate2MX(latLng.getLongitude()));
                        lat.append(Utils.converDoubleCoordinate2MX(latLng.getLatitude()));
                    }else {
                        lon.append(Utils.converDoubleCoordinate2MX(latLng.getLongitude())).append(",");
                        lat.append(Utils.converDoubleCoordinate2MX(latLng.getLatitude())).append(",");
                    }
                }
                param.put("lon",lon.toString());
                param.put("lat",lat.toString());
                param.put("car_plate_no", violationByLonLatQuery.getCarPlateNo());
                param.put("car_kind", violationByLonLatQuery.getCarKind());
                param.put("engine_no", violationByLonLatQuery.getEngineNo());
                param.put("class_no",Utils.converNullToEmpty( violationByLonLatQuery.getClassNo()));
                param.put("regist_no", Utils.converNullToEmpty(violationByLonLatQuery.getRegistNo()));
                paramarray.put(param);
            }
            HashMap<String, Object> params = new HashMap<String, Object>();
            params.put("product_id", product_id);
            String paramStr = paramarray.toString();
            params.put("param",paramarray );
            params.put("mac",generateMac(paramStr) );
            params.put("token",mToken);
            if(startTime !=null&&startTime.getDate()!=null )
            {
                params.put("start_time", startTime.toString());
            }
            if(endTime !=null&&endTime.getDate()!=null  ){
                params.put("end_time", endTime.toString());
            }
            String requestData = Utils.makeUrl(url, params);
            MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
            PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
            requestMessage.timeOutSeconds = timeOutSecs;
            requestMessage.priority = priorityLevel;
            // 添加对应关系
            addCallbackMap(eventId, GETCVDETAILJQFROMLONLAT);
            RequestDispathUtil.submitRequest(requestMessage);
        }catch (Exception e) {
            e.printStackTrace();
        }

        return eventId;
    }

    /**
     * 查询行政区划列表最新版本号
     * @return
     */

    public int getRegionMaxVer(){
       return getRegionMaxVer(Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);

    }

    /**
     * 查询行政区划列表最新版本号
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getRegionMaxVer(int timeOutSecs){
        return getRegionMaxVer(timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     *查询行政区划列表最新版本号
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int getRegionMaxVer( int timeOutSecs, int priorityLevel){
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetRegionMaxVer";
        String requestData = Utils.makeUrl(url, null);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, GETREGIONMAXVER);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
}

    /**
     *查询行政区划列表
     * @return
     */

    public int getCarRegionData(){
        return getCarRegionData(Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 查询行政区划列表
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getCarRegionData(int timeOutSecs){
        return getCarRegionData(timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     *查询行政区划列表
     * @param timeOutSecs  接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int getCarRegionData( int timeOutSecs, int priorityLevel){
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetCarRegionData";
        String requestData = Utils.makeUrl(url, null);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, GETCARREGIONDATA);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 根据经纬度查询行政区编码
     * @param latLng 经纬度
     * @return
     */
    public int getLocAdminCode(LatLng latLng){
        return getLocAdminCode(latLng,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 根据经纬度查询行政区编码
     * @param latLng 经纬度
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getLocAdminCode(LatLng latLng,int timeOutSecs){
        return getLocAdminCode(latLng,timeOutSecs,Config.DEFAULT_PRIORITY);
    }
    /**
     * 根据经纬度查询行政区编码
     * @param latLng 经纬度
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int getLocAdminCode(LatLng latLng, int timeOutSecs, int priorityLevel){
        if( latLng== null){
            if (mOnGetLocAdminCodeListener != null) {
                mOnGetLocAdminCodeListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetLocAdminCode";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("lon", Utils.converDoubleCoordinate2MX(latLng.getLongitude()));
        params.put("lat", Utils.converDoubleCoordinate2MX(latLng.getLatitude()));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, GETLOCADMINCODE);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 获取我的爱车信息
     * @param userId 用户ID
     * @param token 登录唯一标识
     * @return
     */
    public int getMyLoveCarList( String userId,String token){
        return getMyLoveCarList(userId,token,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取我的爱车信息
     * @param userId 用户ID
     * @param token 登录唯一标识
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getMyLoveCarList( String userId,String token,int timeOutSecs){
        return getMyLoveCarList(userId,token,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取我的爱车信息
     * @param userId 用户ID
     * @param token 登录唯一标识
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int getMyLoveCarList( String userId,String token,int timeOutSecs, int priorityLevel){
        if (userId==null||token==null){
            if (mOnGetMyLoveCarListListener != null) {
                mOnGetMyLoveCarListListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/car/queryMyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no",Config.VIN);
        params.put("device_type",Config.DEVICE_TYPE);
        params.put("token",token);
        params.put("user_id", userId);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, USER_ServiceType, USER_ServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, GETMYLOVECARLIST);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 绑定我的爱车信息
     * @param myLoveCarInfo 爱车信息
     * @return
     */
    public int bindingMyLoveCar(MyLoveCarInfo myLoveCarInfo){
        return bindingMyLoveCar(myLoveCarInfo,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 绑定我的爱车信息
     * @param myLoveCarInfo 爱车信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int bindingMyLoveCar(MyLoveCarInfo myLoveCarInfo,int timeOutSecs){
        return bindingMyLoveCar(myLoveCarInfo,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 绑定我的爱车信息
     * @param myLoveCarInfo 爱车信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int bindingMyLoveCar(MyLoveCarInfo myLoveCarInfo, int timeOutSecs, int priorityLevel){
        if( myLoveCarInfo== null||myLoveCarInfo.getToken()==null||myLoveCarInfo.getUserId()==null||myLoveCarInfo.getCarPlateNo()==null){
            if (mOnBindingMyLoveCarListener != null) {
                mOnBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/car/bindingMyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no",Config.VIN);
        params.put("device_type",Config.DEVICE_TYPE);
        params.put("token",myLoveCarInfo.getToken());
        params.put("user_id", myLoveCarInfo.getUserId());
        params.put("car_plate_no", myLoveCarInfo.getCarPlateNo());
        if (myLoveCarInfo.getCarBrand()!=null){
            params.put("car_brand", myLoveCarInfo.getCarBrand());
        }
        if (myLoveCarInfo.getCarType()!=null){
            params.put("car_type", myLoveCarInfo.getCarType());
        }
        if (myLoveCarInfo.getFuelType()!=null){
            params.put("fuel_type", myLoveCarInfo.getFuelType());
        }
        if (myLoveCarInfo.getEngineNo()!=null){
            params.put("engine_no", myLoveCarInfo.getEngineNo());
        }
        if (myLoveCarInfo.getCarVin()!=null){
            params.put("car_vin", myLoveCarInfo.getCarVin());
        }
        if (myLoveCarInfo.getBuyTime()!=null){
            params.put("buy_time", myLoveCarInfo.getBuyTime());
        }
        if (myLoveCarInfo.getInsuranceTime()!=null){
            params.put("insurance_time", myLoveCarInfo.getInsuranceTime());
        }
        if (myLoveCarInfo.isMajor()){
            params.put("is_major",1);
        }else {
            params.put("is_major",0);
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, USER_ServiceType, USER_ServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, BINGMYLOVECAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;

    }

    /**
     * 修改我的爱车信息
     * @param updateMyCarInfoRequest 修改我的爱车信息请求条件
     * @return
     */
    public int updateMyLoveCar(UpdateMyCarInfoRequest updateMyCarInfoRequest){
        return updateMyLoveCar(updateMyCarInfoRequest,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改我的爱车信息
     * @param updateMyCarInfoRequest 修改我的爱车信息请求条件
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int updateMyLoveCar(UpdateMyCarInfoRequest updateMyCarInfoRequest,int timeOutSecs){
        return updateMyLoveCar(updateMyCarInfoRequest,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改我的爱车信息
     * @param updateMyCarInfoRequest 修改我的爱车信息请求条件
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int updateMyLoveCar(UpdateMyCarInfoRequest updateMyCarInfoRequest, int timeOutSecs, int priorityLevel){
        if(updateMyCarInfoRequest==null||updateMyCarInfoRequest.getCarPlateNo()==null||updateMyCarInfoRequest.getToken()==null||updateMyCarInfoRequest.getUserId()==null){
            if (mOnUpdataBindingMyLoveCarListener != null) {
                mOnUpdataBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/car/updateMyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no",Config.VIN);
        params.put("device_type",Config.DEVICE_TYPE);
        params.put("token",updateMyCarInfoRequest.getToken());
        params.put("user_id", updateMyCarInfoRequest.getUserId());
        params.put("car_plate_no_old", updateMyCarInfoRequest.getCarPlateNo());
        if (updateMyCarInfoRequest.getNewCarPlateNo()!=null){
            params.put("car_plate_no_new", updateMyCarInfoRequest.getNewCarPlateNo());
        }
        if (updateMyCarInfoRequest.getCarBrand()!=null){
            params.put("car_brand", updateMyCarInfoRequest.getCarBrand());
        }
        if (updateMyCarInfoRequest.getCarType()!=null){
            params.put("car_type", updateMyCarInfoRequest.getCarType());
        }
        if (updateMyCarInfoRequest.getFuelType()!=null){
            params.put("fuel_type", updateMyCarInfoRequest.getFuelType());
        }
        if (updateMyCarInfoRequest.getEngineNo()!=null){
            params.put("engine_no", updateMyCarInfoRequest.getEngineNo());
        }
        if (updateMyCarInfoRequest.getCarVin()!=null){
            params.put("car_vin", updateMyCarInfoRequest.getCarVin());
        }
        if (updateMyCarInfoRequest.getBuyTime()!=null){
            params.put("buy_time", updateMyCarInfoRequest.getBuyTime());
        }
        if (updateMyCarInfoRequest.getInsuranceTime()!=null){
            params.put("insurance_time", updateMyCarInfoRequest.getInsuranceTime());
        }
        if (updateMyCarInfoRequest.isMajor()){
            params.put("is_major",1);
        }else {
            params.put("is_major",0);
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, USER_ServiceType, USER_ServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, UPDATAMYLOVECAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 解绑我的爱车信息
     * @param unBindingMyLoveCarRequest 解绑我的爱车信息请求数据
     * @return 请求ID
     */
    public int unBindingMyLoveCar(UnBindingMyLoveCarRequest unBindingMyLoveCarRequest){
        return unBindingMyLoveCar(unBindingMyLoveCarRequest,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 解绑我的爱车信息
     * @param unBindingMyLoveCarRequest 解绑我的爱车信息请求数据
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return 请求ID
     */
    public int unBindingMyLoveCar(UnBindingMyLoveCarRequest unBindingMyLoveCarRequest,int timeOutSecs){
        return unBindingMyLoveCar(unBindingMyLoveCarRequest,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 解绑我的爱车信息
     * @param unBindingMyLoveCarRequest 解绑我的爱车信息请求数据
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int unBindingMyLoveCar(UnBindingMyLoveCarRequest unBindingMyLoveCarRequest,int timeOutSecs, int priorityLevel){
        if(unBindingMyLoveCarRequest==null||unBindingMyLoveCarRequest.getCarPlateNo()==null||unBindingMyLoveCarRequest.getToken()==null||unBindingMyLoveCarRequest.getUserId()==null){
            if (mOnUnBindingMyLoveCarListener != null) {
                mOnUnBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/car/unBindingMyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no",Config.VIN);
        params.put("device_type",Config.DEVICE_TYPE);
        params.put("token",unBindingMyLoveCarRequest.getToken());
        params.put("user_id", unBindingMyLoveCarRequest.getUserId());
        params.put("car_plate_no", unBindingMyLoveCarRequest.getCarPlateNo());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, USER_ServiceType, USER_ServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, UNBINGMYLOVECAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 获取违章车辆列表
     * @param userId 用户ID
     * @return
     */
    public int getPeccancyCarList(String userId){
        return getPeccancyCarList(userId,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取违章车辆列表
     * @param userId 用户ID
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int getPeccancyCarList(String userId,int timeOutSecs){
        return getPeccancyCarList(userId,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取违章车辆列表
     * @param userId 用户ID
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int getPeccancyCarList(String userId,int timeOutSecs, int priorityLevel){
        int eventId = RequestDispathUtil.createEventId();
        String url = "GetPeccancyCarList";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", product_id);
        params.put("user_id", userId);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, GETPECCANCTCARLIST);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 添加违章车辆
     * @param userId 用户ID
     * @param peccancyCarInfo 违章车辆信息
     * @return
     */
    public int addPeccancyCar(String userId,PeccancyCarInfo peccancyCarInfo) {
        return addPeccancyCar(userId,peccancyCarInfo,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 添加违章车辆
     * @param userId 用户ID
     * @param peccancyCarInfo 违章车辆信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int addPeccancyCar(String userId,PeccancyCarInfo peccancyCarInfo,int timeOutSecs){
        return addPeccancyCar(userId,peccancyCarInfo,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 添加违章车辆
     * @param userId 用户ID
     * @param peccancyCarInfo 违章车辆信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int addPeccancyCar(String userId,PeccancyCarInfo peccancyCarInfo,int timeOutSecs, int priorityLevel){
        if(peccancyCarInfo==null||peccancyCarInfo.getCarPlateNo()==null||peccancyCarInfo.getCityCodes()==null||peccancyCarInfo.getEngineNo()==null||peccancyCarInfo.getCommentsName()==null||peccancyCarInfo.getLatLngs()==null){
            if (mOnAddPeccancyCarListener != null) {
                mOnAddPeccancyCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "AddPeccancyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", product_id);
        params.put("user_id", userId);
        params.put("car_plate_no", peccancyCarInfo.getCarPlateNo());
        List<String> cityCodes = peccancyCarInfo.getCityCodes();
        StringBuffer city = new StringBuffer();
        for (int i = 0; i<cityCodes.size(); i++){
            String cityCode = cityCodes.get(i);
            if(i == cityCodes.size()-1){
                city.append(cityCode);
            }else {
                city.append(cityCode).append(",");
            }
        }
        params.put("city",city.toString());
        params.put("engineNo", peccancyCarInfo.getEngineNo());
        params.put("carVin", Utils.converNullToEmpty(peccancyCarInfo.getCarVin()));
        params.put("commentsName", peccancyCarInfo.getCommentsName());
        StringBuffer lon = new StringBuffer();
        StringBuffer lat = new StringBuffer();
        List<LatLng> list = peccancyCarInfo.getLatLngs();
        int size = list.size();
        for (int i = 0; i<size; i++){
            LatLng latLng = list.get(i);
            double latitem = latLng.getLatitude();
            double lonitem = latLng.getLongitude();
            if(i == size-1){
                lon.append(Utils.converDoubleCoordinate2MX(lonitem));
                lat.append(Utils.converDoubleCoordinate2MX(latitem));
            }else {
                lon.append(Utils.converDoubleCoordinate2MX(lonitem)).append(",");
                lat.append(Utils.converDoubleCoordinate2MX(latitem)).append(",");
            }
        }
        params.put("lon", lon.toString());
        params.put("lat", lat.toString());
        if (peccancyCarInfo.getCityNames()!=null){
            List<String> cityNames = peccancyCarInfo.getCityNames();
            StringBuffer citySbf = new StringBuffer();
            for (int i=0;i<cityNames.size();i++){
                String cityName = cityNames.get(i);
                if(i == cityCodes.size()-1){
                    citySbf.append(cityName);
                }else {
                    citySbf.append(cityName).append(",");
                }
            }
            params.put("cityName",citySbf.toString());
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, ADDPECCANCTCAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }

    /**
     * 修改违章车辆
     * @param userId 用户ID
     * @param newCarPlateNo 新车牌号
     * @param peccancyCarInfo 车辆信息
     * @return
     */


    public int  updatePeccancyCar(String userId,String newCarPlateNo,PeccancyCarInfo peccancyCarInfo){
        return updatePeccancyCar(userId,newCarPlateNo,peccancyCarInfo,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改违章车辆
     * @param userId 用户ID
     * @param newCarPlateNo 新车牌号
     * @param peccancyCarInfo 车辆信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int updatePeccancyCar(String userId,String newCarPlateNo,PeccancyCarInfo peccancyCarInfo,int timeOutSecs){
        return updatePeccancyCar(userId,newCarPlateNo,peccancyCarInfo,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改违章车辆信息
     * @param userId 用户ID
     * @param newCarPlateNo 新车牌号
     * @param peccancyCarInfo 车辆信息
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int updatePeccancyCar(String userId,String newCarPlateNo,PeccancyCarInfo peccancyCarInfo,int timeOutSecs, int priorityLevel){
        if(newCarPlateNo==null||peccancyCarInfo==null||peccancyCarInfo.getCarPlateNo()==null||peccancyCarInfo.getCityCodes()==null||peccancyCarInfo.getEngineNo()==null||peccancyCarInfo.getCommentsName()==null||peccancyCarInfo.getLatLngs()==null){
            if (mOnUpdatePeccancyCarListener != null) {
                mOnUpdatePeccancyCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "UpdatePeccancyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", product_id);
        params.put("user_id", userId);
        params.put("car_plate_no", peccancyCarInfo.getCarPlateNo());
        List<String> cityCodes = peccancyCarInfo.getCityCodes();
        StringBuffer city = new StringBuffer();
        for (int i = 0; i<cityCodes.size(); i++){
            String cityCode = cityCodes.get(i);
            if(i == cityCodes.size()-1){
                city.append(cityCode);
            }else {
                city.append(cityCode).append(",");
            }
        }
        params.put("city",city.toString());
        params.put("engineNo", peccancyCarInfo.getEngineNo());
        params.put("carVin", peccancyCarInfo.getCarVin());
        params.put("commentsName", peccancyCarInfo.getCommentsName());
        params.put("new_car_plate_no", newCarPlateNo);
        StringBuffer lon = new StringBuffer();
        StringBuffer lat = new StringBuffer();
        List<LatLng> list = peccancyCarInfo.getLatLngs();
        int size = list.size();
        for (int i = 0; i<size; i++){
            LatLng latLng = list.get(i);
            double latitem = latLng.getLatitude();
            double lonitem = latLng.getLongitude();
            if(i == size-1){
                lon.append(Utils.converDoubleCoordinate2MX(lonitem));
                lat.append(Utils.converDoubleCoordinate2MX(latitem));
            }else {
                lon.append(Utils.converDoubleCoordinate2MX(lonitem)).append(",");
                lat.append(Utils.converDoubleCoordinate2MX(latitem)).append(",");
            }
        }
        params.put("lon", lon.toString());
        params.put("lat", lat.toString());
        if (peccancyCarInfo.getCityNames()!=null){
            List<String> cityNames = peccancyCarInfo.getCityNames();
            StringBuffer citySbf = new StringBuffer();
            for (int i=0;i<cityNames.size();i++){
                String cityName = cityNames.get(i);
                if(i == cityCodes.size()-1){
                    citySbf.append(cityName);
                }else {
                    citySbf.append(cityName).append(",");
                }
            }
            params.put("cityName",citySbf.toString());
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, UPDATAPECCANCTCAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;
    }
    /**
     * 删除违章车辆
     * @param userId 用户ID
     * @param carPlateNo 车牌号
     * @return
     */
    public int deletePeccancyCar(String userId,String carPlateNo){
        return deletePeccancyCar(userId,carPlateNo,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }
    /**
     * 删除违章车辆
     * @param userId 用户ID
     * @param carPlateNo 车牌号
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int deletePeccancyCar(String userId,String carPlateNo,int timeOutSecs){
        return deletePeccancyCar(userId,carPlateNo,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 删除违章车辆
     * @param userId 用户ID
     * @param carPlateNo 车牌号
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */

    public int deletePeccancyCar(String userId,String carPlateNo,int timeOutSecs, int priorityLevel){
        if(carPlateNo==null){
            if (mOnDeletePeccancyCarListener != null) {
                mOnDeletePeccancyCarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "DeletePeccancyCar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", product_id);
        params.put("user_id", userId);
        params.put("car_plate_no", carPlateNo);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, DELETEPECCANCTCAR);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;

    }

    /**
     * 获取违章列表
     * @param carViolationInfo
     * @return
     */
    public int queryCarViolation(CarViolationInfo carViolationInfo){
        return queryCarViolation(carViolationInfo,Config.DEFAULT_TIMEOUT_SECS,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取违章列表
     * @param carViolationInfo
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @return
     */
    public int queryCarViolation(CarViolationInfo carViolationInfo,int timeOutSecs){
        return queryCarViolation(carViolationInfo,timeOutSecs,Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取违章列表
     * @param carViolationInfo
     * @param timeOutSecs 接口超时时间，单位为秒，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int queryCarViolation(CarViolationInfo carViolationInfo,int timeOutSecs, int priorityLevel){
        if(carViolationInfo==null
                ||carViolationInfo.getCarNumber()==null
                ||carViolationInfo.getCarCode()==null
                ||carViolationInfo.getCarDriveNumber()==null){
            if (mOnQueryCarViolationListener != null) {
                mOnQueryCarViolationListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "queryCarViolation";
        HashMap<String, Object> params = new HashMap<String, Object>();
        if (carViolationInfo.getCarType()!=null){
            params.put("carType", carViolationInfo.getCarType());
        }
        params.put("carNumber", carViolationInfo.getCarNumber());
        params.put("carCode", carViolationInfo.getCarCode());
        params.put("carDriveNumber", carViolationInfo.getCarDriveNumber());
        if (carViolationInfo.getCarOwner()!=null){
            params.put("carOwner", carViolationInfo.getCarOwner());
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, VIOLATION_NEW_ServiceType, VIOLATION_NEW_serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        // 添加对应关系
        addCallbackMap(eventId, QUERYCARVIOLATION);
        RequestDispathUtil.submitRequest(requestMessage);
        return eventId;

    }
    /**
     * 生成签名
     * @param param
     * @return
     */
    private String  generateMac(String param){
        String text = "token="+mToken+"&param="+param;
        return Utils.md5((text + mMerchantKey)).toUpperCase();

    }
    public interface OnGetCvDetailFromLonAndLatListener extends CallBackListener {
        public void onGetCvDetailFromLonAndLat(int requestId, PeccancyResult peccancyResult);
    }
    public interface OnGetRegionMaxVerListener extends CallBackListener{
        public void onGetRegionMaxVer(int requestId, int maxVer);
    }

    public interface OnGetCarRegionDataListener extends CallBackListener{
        public void onGetCarRegionData(int requestId, String carRegionData);
    }
    public interface OnGetLocAdminCodeListener extends CallBackListener{
        public void onGetLocAdminCode(int requestId, LocAdminCodeResult city);
    }

    /**
     * 该接口为绑定车辆信息接口（没有用处）
     */
    public interface OnSaveCVCarInfoListener extends CallBackListener{
        public void onSaveCVCarInfosuccess();
    }


    public interface OnGetMyLoveCarListListener extends CallBackListener{
        public void onGetMyLoveCarList(int requestId, List<MyLoveCarInfo> list);
    }
    public interface OnBindingMyLoveCarListener extends CallBackListener{
        public void onBindingMyLoveCar();
    }
    public interface OnUpdataBindingMyLoveCarListener extends CallBackListener{
        public void onUpdataBindingMyLoveCar();
    }
    public interface OnUnBindingMyLoveCarListener extends CallBackListener{
        public void onUnBindingMyLoveCar();
    }
    public interface OnGetPeccancyCarListListener extends CallBackListener{
        public void onGetPeccancyCarList(int requestId, List<PeccancyCarInfo> peccancyCarInfos);
    }
    public interface OnAddPeccancyCarListener extends CallBackListener{
        public void onAddPeccancyCar();
    }
    public interface OnUpdatePeccancyCarListener extends CallBackListener{
        public void onUpdatePeccancyCar();
    }
    public interface OnDeletePeccancyCarListener extends CallBackListener{
        public void onDeletePeccancyCar();
    }
    public interface OnQueryCarViolationListener extends CallBackListener{
        public void onQueryCarViolation(int requestId, CarViolationResult carViolationResult);
    }
    OnGetCvDetailFromLonAndLatListener mOnGetCvDetailFromLonAndLatListener;
    OnGetRegionMaxVerListener mOnGetRegionMaxVerListener;
    OnGetCarRegionDataListener mOnGetCarRegionDataListener;
    OnGetLocAdminCodeListener mOnGetLocAdminCodeListener;
    /**
     * 该处为绑定车辆信息接口（没有用处）
     */
    OnSaveCVCarInfoListener mOnSaveCVCarInfoListener;
    OnGetMyLoveCarListListener mOnGetMyLoveCarListListener;
    OnBindingMyLoveCarListener mOnBindingMyLoveCarListener;
    OnUpdataBindingMyLoveCarListener mOnUpdataBindingMyLoveCarListener;
    OnUnBindingMyLoveCarListener mOnUnBindingMyLoveCarListener;
    OnGetPeccancyCarListListener mOnGetPeccancyCarListListener;
    OnAddPeccancyCarListener mOnAddPeccancyCarListener;
    OnUpdatePeccancyCarListener mOnUpdatePeccancyCarListener;
    OnDeletePeccancyCarListener mOnDeletePeccancyCarListener;
    OnQueryCarViolationListener mOnQueryCarViolationListener;

    public void setOnGetCvDetailFromLonAndLatListener(OnGetCvDetailFromLonAndLatListener onGetCvDetailFromLonAndLatListener) {
        this.mOnGetCvDetailFromLonAndLatListener = onGetCvDetailFromLonAndLatListener;
    }

    public void setOnGetRegionMaxVerListener(OnGetRegionMaxVerListener OnGetRegionMaxVerListener) {
        this.mOnGetRegionMaxVerListener = OnGetRegionMaxVerListener;
    }

    public void setOnGetCarRegionDataListener(OnGetCarRegionDataListener OnGetCarRegionDataListener) {
        this.mOnGetCarRegionDataListener = OnGetCarRegionDataListener;
    }

    public void setOnGetLocAdminCodeListener(OnGetLocAdminCodeListener OnGetLocAdminCodeListener) {
        this.mOnGetLocAdminCodeListener = OnGetLocAdminCodeListener;
    }

    public void setOnGetMyLoveCarListListener(OnGetMyLoveCarListListener OnGetMyLoveCarListListener) {
        this.mOnGetMyLoveCarListListener = OnGetMyLoveCarListListener;
    }

    public void setOnBindingMyLoveCarListener(OnBindingMyLoveCarListener OnBindingMyLoveCarListener) {
        this.mOnBindingMyLoveCarListener = OnBindingMyLoveCarListener;
    }
    public void setOnUpDataBindingMyLoveCarListener(OnUpdataBindingMyLoveCarListener OnUpdataBindingMyLoveCarListener) {
        this.mOnUpdataBindingMyLoveCarListener = OnUpdataBindingMyLoveCarListener;
    }
    public void setOnUnBindingMyLoveCarListener(OnUnBindingMyLoveCarListener OnUnBindingMyLoveCarListener) {
        this.mOnUnBindingMyLoveCarListener = OnUnBindingMyLoveCarListener;
    }

    public void setOnGetPeccancyCarListListener(OnGetPeccancyCarListListener OnGetPeccancyCarListListener) {
        this.mOnGetPeccancyCarListListener = OnGetPeccancyCarListListener;
    }
    public void setOnAddPeccancyCarListListener(OnAddPeccancyCarListener OnAddPeccancyCarListener) {
        this.mOnAddPeccancyCarListener = OnAddPeccancyCarListener;
    }
    public void setOnUpdatePeccancyCarListener(OnUpdatePeccancyCarListener OnUpdatePeccancyCarListener) {
        this.mOnUpdatePeccancyCarListener = OnUpdatePeccancyCarListener;
    }

    public void setOnDeletePeccancyCarListener(OnDeletePeccancyCarListener OnDeletePeccancyCarListener) {
        this.mOnDeletePeccancyCarListener = OnDeletePeccancyCarListener;
    }

    /**
     * 该处为绑定车辆信息接口（没有用处）
     */
    public void setOnSaveCVCarInfoListener(OnSaveCVCarInfoListener OnSaveCVCarInfoListener) {
        this.mOnSaveCVCarInfoListener = OnSaveCVCarInfoListener;
    }
    public void setOnQueryCarViolationListener(OnQueryCarViolationListener onQueryCarViolationListener) {
        this.mOnQueryCarViolationListener = onQueryCarViolationListener;
    }


    private void addCallbackMap(int eventId, int type) {
        super.addCallbackMap(eventId, Peccancy.this);

        synchronized (listenertypeHashMap) {
            listenertypeHashMap.put(eventId, type);
        }
    }

    @Override
    protected void removeCallbackMap(int eventId) {
        super.removeCallbackMap(eventId);
        synchronized (listenertypeHashMap) {
            listenertypeHashMap.remove(eventId);
        }
    }

    public void cancleRequest(List<Integer> requestId) {
        for (int eventId: requestId) {
            removeCallbackMap(eventId);
        }
    }

    @Override
    protected void callTimeOut(int requestHandleId) {
        int type = listenertypeHashMap.get(requestHandleId);
        removeCallbackMap(requestHandleId);
        switch (type) {
            case GETCVDETAILFROMLONLAT://1
                if (mOnGetCvDetailFromLonAndLatListener != null) {
                    mOnGetCvDetailFromLonAndLatListener.onTimeOut();
                }
                break;
            case GETCVDETAILJQFROMLONLAT://2
                if (mOnGetCvDetailFromLonAndLatListener != null) {
                    mOnGetCvDetailFromLonAndLatListener.onTimeOut();
                }
                break;
            case GETREGIONMAXVER://3
                if (mOnGetRegionMaxVerListener != null) {
                    mOnGetRegionMaxVerListener.onTimeOut();
                }
                break;
            case GETCARREGIONDATA://4
                if (mOnGetCarRegionDataListener != null) {
                    mOnGetCarRegionDataListener.onTimeOut();
                }
                break;
            case GETLOCADMINCODE://5
                if (mOnGetLocAdminCodeListener != null) {
                    mOnGetLocAdminCodeListener.onTimeOut();
                }
                break;
            case GETMYLOVECARLIST://7
                if (mOnGetMyLoveCarListListener != null) {
                    mOnGetMyLoveCarListListener.onTimeOut();
                }
                break;
            case BINGMYLOVECAR://8
                if (mOnBindingMyLoveCarListener != null) {
                    mOnBindingMyLoveCarListener.onTimeOut();
                }
                break;
            case UPDATAMYLOVECAR://9
                if (mOnUpdataBindingMyLoveCarListener != null) {
                    mOnUpdataBindingMyLoveCarListener.onTimeOut();
                }
                break;
            case UNBINGMYLOVECAR://10
                if (mOnUnBindingMyLoveCarListener != null) {
                    mOnUnBindingMyLoveCarListener.onTimeOut();
                }
                break;
            case GETPECCANCTCARLIST://11
                if (mOnGetPeccancyCarListListener != null) {
                    mOnGetPeccancyCarListListener.onTimeOut();
                }
                break;
            case ADDPECCANCTCAR://12
                if (mOnAddPeccancyCarListener != null) {
                    mOnAddPeccancyCarListener.onTimeOut();
                }
                break;
            case UPDATAPECCANCTCAR://13
                if (mOnUpdatePeccancyCarListener != null) {
                    mOnUpdatePeccancyCarListener.onTimeOut();
                }
                break;
            case DELETEPECCANCTCAR://14
                if (mOnDeletePeccancyCarListener != null) {
                    mOnDeletePeccancyCarListener.onTimeOut();
                }
                break;
            case QUERYCARVIOLATION://14
                if (mOnQueryCarViolationListener != null) {
                    mOnQueryCarViolationListener.onTimeOut();
                }
                break;
        }
    }
    @Override
    protected void onCallBack(int requestHandleId, String response,boolean hasDSPTError,int errorCode,String errMsg) {
        Utils.loge("response = "+response);
        int type = listenertypeHashMap.get(requestHandleId);
        removeCallbackMap(requestHandleId);
        switch (type) {
            case GETCVDETAILFROMLONLAT:
                if (mOnGetCvDetailFromLonAndLatListener != null) {
                    if(hasDSPTError){
                        mOnGetCvDetailFromLonAndLatListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        PeccancyResult peccancyResult = new PeccancyResult();
                        List<PeccancyItem> list = new ArrayList<PeccancyItem>();
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            if(jsonObject.has("data")){
                                JSONArray  dataarray = jsonObject.getJSONArray("data");
                                for (int j = 0; j < dataarray.length(); j++) {
                                    JSONObject dataObj = dataarray.getJSONObject(j);
                                    if(dataObj.has("carPlateNo")){
                                        String carPlateNo = dataObj.getString("carPlateNo");
                                        peccancyResult.setCarPlateNo(carPlateNo);
                                    }
                               if(dataObj.has("detail")){
                                   JSONArray detailarray = dataObj.getJSONArray("detail");
                                   PeccancyItem item;
                                   for (int i = 0; i < detailarray.length(); i++) {
                                       JSONObject object = detailarray.getJSONObject(i);
                                       item = new PeccancyItem();
                                       if(object.has("lon")&&object.has("lat")){
                                           LatLng latLng = new LatLng();
                                           latLng.setLongitude(Utils.converMX2DoubleCoordinate(object.getInt("lon")));
                                           latLng.setLatitude(Utils.converMX2DoubleCoordinate(object.getInt("lat")));
                                           item.setLatLng(latLng);
                                       }
                                     if(object.has("msg")){
                                         item.setMsg(object.getString("msg"));
                                     }
                                       if(object.has("status")){
                                           item.setStatus(object.getInt("status"));
                                       }

                                       List<PeccancyInfo> violationInfos =  new ArrayList<PeccancyInfo>();
                                       if(object.has("lists")){
                                           JSONArray jsonArray = object.getJSONArray("lists");
                                           for (int p = 0; p < jsonArray.length(); p++) {
                                               JSONObject listobj = jsonArray.getJSONObject(p);
                                               Gson gson = new Gson();
                                               PeccancyInfo peccancyInfo = gson.fromJson(listobj.toString(), PeccancyInfo.class);
                                               violationInfos.add(peccancyInfo);
                                           }
                                           item.setViolationInfos(violationInfos);
                                           list.add(item);
                                       }
                                   }
                                  }
                                    peccancyResult.setDetail(list);
                                }
                            }
                            mOnGetCvDetailFromLonAndLatListener.onGetCvDetailFromLonAndLat(requestHandleId, peccancyResult);
                        }else{
                            mOnGetCvDetailFromLonAndLatListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;

            case GETCVDETAILJQFROMLONLAT:
                if (mOnGetCvDetailFromLonAndLatListener != null) {
                    if(hasDSPTError){
                        mOnGetCvDetailFromLonAndLatListener.onFail(errorCode,errMsg);
                        return;
                    }

                    try {
                        PeccancyResult peccancyResult = new PeccancyResult();
                        List<PeccancyItem> list = new ArrayList<PeccancyItem>();
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            if(jsonObject.has("data")){
                                JSONArray  dataarray = jsonObject.getJSONArray("data");
                                for (int j = 0; j < dataarray.length(); j++) {
                                    JSONObject dataObj = dataarray.getJSONObject(j);
                                    if(dataObj.has("carPlateNo")){
                                        String carPlateNo = dataObj.getString("carPlateNo");
                                        peccancyResult.setCarPlateNo(carPlateNo);
                                    }
                                    if(dataObj.has("detail")){
                                        JSONArray detailarray = dataObj.getJSONArray("detail");
                                        PeccancyItem item;
                                        for (int i = 0; i < detailarray.length(); i++) {
                                            JSONObject object = detailarray.getJSONObject(i);
                                            item = new PeccancyItem();
                                            if(object.has("lon")&&object.has("lat")){
                                                LatLng latLng = new LatLng();
                                                latLng.setLongitude(Utils.converMX2DoubleCoordinate(object.getInt("lon")));
                                                latLng.setLatitude(Utils.converMX2DoubleCoordinate(object.getInt("lat")));
                                                item.setLatLng(latLng);
                                            }
                                            if(object.has("msg")){
                                                item.setMsg(object.getString("msg"));
                                            }
                                            if(object.has("status")){
                                                item.setStatus(object.getInt("status"));
                                            }
                                            List<PeccancyInfo> violationInfos =  new ArrayList<PeccancyInfo>();
                                            if(object.has("lists")){
                                                JSONArray jsonArray = object.getJSONArray("lists");
                                                for (int p = 0; p < jsonArray.length(); p++) {
                                                    JSONObject listobj = jsonArray.getJSONObject(p);
                                                    Gson gson = new Gson();
                                                    PeccancyInfo peccancyInfo = gson.fromJson(listobj.toString(), PeccancyInfo.class);
                                                    violationInfos.add(peccancyInfo);
                                                    item.setViolationInfos(violationInfos);
                                                }
                                                list.add(item);

                                            }
                                        }
                                    }
                                    peccancyResult.setDetail(list);
                                }
                            }
                            mOnGetCvDetailFromLonAndLatListener.onGetCvDetailFromLonAndLat(requestHandleId, peccancyResult);
                        }else{
                            mOnGetCvDetailFromLonAndLatListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetCvDetailFromLonAndLatListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;
            case GETREGIONMAXVER:
                if (mOnGetRegionMaxVerListener != null) {
                    if(hasDSPTError){
                        mOnGetRegionMaxVerListener.onFail(errorCode,errMsg);
                        return;
                    }

                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            int maxVer = jsonObject.getInt("maxVer");
                            mOnGetRegionMaxVerListener.onGetRegionMaxVer(requestHandleId, maxVer);
                        }else{
                            mOnGetRegionMaxVerListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetRegionMaxVerListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }

                break;
            case GETCARREGIONDATA://查询行政区划列表
                if (mOnGetCarRegionDataListener != null) {
                    if(hasDSPTError){
                        mOnGetCarRegionDataListener.onFail(errorCode,errMsg);
                        return;
                    }

                    try {
                        mOnGetCarRegionDataListener.onGetCarRegionData(requestHandleId, response);
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetCarRegionDataListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;
            case GETLOCADMINCODE://根据经纬度查询行政区编码
                if (mOnGetLocAdminCodeListener != null) {
                    if(hasDSPTError){
                        mOnGetLocAdminCodeListener.onFail(errorCode,errMsg);
                        return;
                    }

                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            LocAdminCodeResult city = new LocAdminCodeResult();
                            if(jsonObject.has("city")){
                                city.setCityName(jsonObject.getString("city"));
                            }
                            if(jsonObject.has("adminCode")){
                                city.setCurrentCityCode(jsonObject.getString("adminCode"));
                            }
                            if(jsonObject.has("province")){
                                city.setProvName(jsonObject.getString("province"));
                            }
                            if(jsonObject.has("engine")){
                                city.setEngine(jsonObject.getInt("engine"));
                            }
                            if(jsonObject.has("engineno")){
                                city.setEngineno(String.valueOf(jsonObject.getInt("engineno")));
                            }if(jsonObject.has("frame")){
                                city.setFrame(jsonObject.getInt("frame"));
                            }
                            if(jsonObject.has("frameno")){
                                city.setFrameno(jsonObject.getString("frameno"));
                            }
                            if(jsonObject.has("regist")){
                                city.setRegist(jsonObject.getInt("regist"));
                            }
                            if(jsonObject.has("registno")){
                                city.setRegistno(jsonObject.getString("registno"));
                            }
                            if(jsonObject.has("lon")){
                                city.setLon(Utils.converMX2DoubleCoordinate(Integer.parseInt(jsonObject.getString("lon"))));
                            }
                            if(jsonObject.has("lat")){
                                city.setLat(Utils.converMX2DoubleCoordinate(Integer.parseInt(jsonObject.getString("lat"))));
                            }
                            if(jsonObject.has("shortname")){
                                city.setShortname(jsonObject.getString("shortname"));
                            }
                            mOnGetLocAdminCodeListener.onGetLocAdminCode(requestHandleId, city);
                        }else{
                            mOnGetLocAdminCodeListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetLocAdminCodeListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;
            case GETMYLOVECARLIST://获取我的爱车信息
                if (mOnGetMyLoveCarListListener != null) {
                    if(hasDSPTError){
                        mOnGetMyLoveCarListListener.onFail(errorCode,errMsg);
                        return;
                    }

                    try {
                        List<MyLoveCarInfo> list = new ArrayList<MyLoveCarInfo>();
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            JSONArray dataarray = jsonObject.getJSONArray("data");
                                  for(int i=0;i<dataarray.length();i++){
                                      MyLoveCarInfo myLoveCarInfo = new MyLoveCarInfo();
                                      JSONObject object = dataarray.getJSONObject(i);
                                      if (object.has("engineNo")){
                                          myLoveCarInfo.setEngineNo(Utils.converNullToEmpty(object.getString("engineNo")));
                                      }
                                      if (object.has("carVin")){
                                          myLoveCarInfo.setCarVin(Utils.converNullToEmpty(object.getString("carVin")));
                                      }
                                      if (object.has("carPlateNo")){
                                          myLoveCarInfo.setCarPlateNo(Utils.converNullToEmpty(object.getString("carPlateNo")));
                                      }
                                      if (object.has("carType")){
                                          myLoveCarInfo.setCarType(Utils.converNullToEmpty(object.getString("carType")));
                                      }
                                      if (object.has("fuelType")){
                                          myLoveCarInfo.setFuelType(Utils.converNullToEmpty(object.getString("fuelType")));
                                      }
                                      if (object.has("insuranceTime")){
                                          myLoveCarInfo.setInsuranceTime(Utils.converNullToEmpty(object.getString("insuranceTime")));
                                      }
                                      if (object.has("carBrand")){
                                          myLoveCarInfo.setCarBrand(Utils.converNullToEmpty(object.getString("carBrand")));
                                      }
                                      if (object.has("buyTime")){
                                          myLoveCarInfo.setBuyTime(Utils.converNullToEmpty(object.getString("buyTime")));
                                      }
                                      if (object.has("isMajor")){
                                          if (object.getInt("isMajor")==1){
                                              myLoveCarInfo.setIsMajor(true);
                                          }else if (object.getInt("isMajor")==0){
                                              myLoveCarInfo.setIsMajor(false);
                                          }
                                      }
                                      list.add(myLoveCarInfo);
                                  }
                            mOnGetMyLoveCarListListener.onGetMyLoveCarList(requestHandleId,list);
                        }else if (respCode == Constants.RESPCODE_MYLOVECAR){
                            mOnGetMyLoveCarListListener.onGetMyLoveCarList(requestHandleId, new ArrayList<MyLoveCarInfo>());
                        } else{
                            mOnGetMyLoveCarListListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetMyLoveCarListListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;
            case BINGMYLOVECAR://绑定我的爱车信息
                if (mOnBindingMyLoveCarListener != null) {
                    if(hasDSPTError){
                        mOnBindingMyLoveCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnBindingMyLoveCarListener.onBindingMyLoveCar();
                        }else{
                            mOnBindingMyLoveCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case UPDATAMYLOVECAR://修改我的爱车信息
                if (mOnUpdataBindingMyLoveCarListener != null) {
                    if(hasDSPTError){
                        mOnUpdataBindingMyLoveCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnUpdataBindingMyLoveCarListener.onUpdataBindingMyLoveCar();
                        }else{
                            mOnUpdataBindingMyLoveCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnUpdataBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case UNBINGMYLOVECAR://解绑我的爱车信息
                if (mOnUnBindingMyLoveCarListener != null) {
                    if(hasDSPTError){
                        mOnUnBindingMyLoveCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnUnBindingMyLoveCarListener.onUnBindingMyLoveCar();
                        }else{
                            mOnUnBindingMyLoveCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnUnBindingMyLoveCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case GETPECCANCTCARLIST://获取违章车辆列表
                if (mOnGetPeccancyCarListListener != null) {
                    if(hasDSPTError){
                        mOnGetPeccancyCarListListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        List<PeccancyCarInfo> peccancyCarInfos = new ArrayList<PeccancyCarInfo>();
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            JSONArray carListarray = jsonObject.getJSONArray("carList");
                            if(carListarray != null){
                                for (int i = 0; i < carListarray.length(); i++) {

                                    PeccancyCarInfo peccancyCarInfo = new PeccancyCarInfo();
                                    JSONObject carObject = carListarray.getJSONObject(i);
                                    if(carObject.has("carPlateNo")){
                                        peccancyCarInfo.setCarPlateNo(carObject.getString("carPlateNo"));
                                    }
                                    if(carObject.has("engineNo")){
                                        peccancyCarInfo.setEngineNo(carObject.getString("engineNo"));
                                    }
                                    if(carObject.has("city")){
                                        String city = carObject.getString("city");
                                        String[] cityCodes =  city.split(",");
                                        List<String> citylist = new ArrayList<String>();
                                        for (int c = 0; c < cityCodes.length; c++){
                                            String citycode = cityCodes[c];
                                            citylist.add(citycode);
                                        }
                                        peccancyCarInfo.setCityCodes(citylist);
                                    }
                                    if (carObject.has("cityName")){
                                        String name = carObject.getString("cityName");
                                        String[] cityNames =  name.split(",");
                                        List<String> cityNamesList = new ArrayList<String>();
                                        for (int j=0;j<cityNames.length;j++){
                                            String cityName = cityNames[j];
                                            cityNamesList.add(cityName);
                                        }
                                        peccancyCarInfo.setCityNames(cityNamesList);
                                    }
                                    if(carObject.has("commentsName")){
                                        peccancyCarInfo.setCommentsName(carObject.getString("commentsName"));
                                    }
                                    if(carObject.has("carVin")){
                                        peccancyCarInfo.setCarVin(carObject.getString("carVin"));
                                    }
                                    if(carObject.has("lon")||carObject.has("lat")){
                                        String lon = carObject.getString("lon");
                                        String lat = carObject.getString("lat");
                                        String[] lonarray =  lon.split(",");
                                        String[] latarray =  lat.split(",");
                                        List<LatLng> list = new ArrayList<LatLng>();
                                          for(int j = 0;j<lonarray.length;j++){
                                              LatLng latLog = new LatLng();
                                              latLog.setLongitude(Utils.converMX2DoubleCoordinate(Integer.parseInt(lonarray[j])));
                                              latLog.setLatitude(Utils.converMX2DoubleCoordinate(Integer.parseInt(latarray[j])));
                                              list.add(latLog);
                                          }
                                        peccancyCarInfo.setLatLngs(list);
                                    }
                                    peccancyCarInfos.add(peccancyCarInfo);
                            }
                                mOnGetPeccancyCarListListener.onGetPeccancyCarList(requestHandleId, peccancyCarInfos);
                            }
                        }else{
                            mOnGetPeccancyCarListListener.onFail(respCode, "出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnGetPeccancyCarListListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }

                }
                break;
            case ADDPECCANCTCAR://添加违章车辆
                if (mOnAddPeccancyCarListener != null) {
                    if(hasDSPTError){
                        mOnAddPeccancyCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnAddPeccancyCarListener.onAddPeccancyCar();
                        }else{
                            mOnAddPeccancyCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnAddPeccancyCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case UPDATAPECCANCTCAR://修改违章车辆
                if (mOnUpdatePeccancyCarListener != null) {
                    if(hasDSPTError){
                        mOnUpdatePeccancyCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnUpdatePeccancyCarListener.onUpdatePeccancyCar();
                        }else{
                            mOnUpdatePeccancyCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnUpdatePeccancyCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case DELETEPECCANCTCAR://删除违章车辆
                if (mOnDeletePeccancyCarListener != null) {
                    if(hasDSPTError){
                        mOnDeletePeccancyCarListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            mOnDeletePeccancyCarListener.onDeletePeccancyCar();
                        }else{
                            mOnDeletePeccancyCarListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnDeletePeccancyCarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case QUERYCARVIOLATION://获取违章列表
                if (mOnQueryCarViolationListener != null) {
                    if(hasDSPTError){
                        mOnQueryCarViolationListener.onFail(errorCode,errMsg);
                        return;
                    }
                    try {
                        JSONTokener jsonParser = new JSONTokener(response);
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode ==  Constants.RESPCODE_SUCCESS) {
                            Gson gson = new Gson();
                            CarViolationResult carViolationResult = gson.fromJson(response, CarViolationResult.class);
//                            JSONArray jsonArray = jsonObject.getJSONArray("records");
//                            List<CarViolationResultData> records = null;
//
//                            int size = jsonArray.length();
//                            if (size>0) {
//                                records = new ArrayList<CarViolationResultData>(size);
//                                for (int i = 0; i < size; i++) {
//                                    JSONObject dataObject = jsonArray.getJSONObject(i);
//                                    CarViolationResultData carViolationResult = new CarViolationResultData();
//                                    carViolationResult.setTime(dataObject.getString("time"));
//                                    carViolationResult.setLocation(dataObject.getString("location"));
//                                    carViolationResult.setReason(dataObject.getString("reason"));
//                                    carViolationResult.setCount(dataObject.getString("count"));
//                                    carViolationResult.setStatus(dataObject.getString("status"));
//                                    carViolationResult.setDegree(dataObject.getString("degree"));
//                                    if (dataObject.has("telephone")){
//                                        carViolationResult.setTelephone(dataObject.getString("telephone"));
//                                    }
//                                    if (dataObject.has("locationName")){
//                                        carViolationResult.setLocationName(dataObject.getString("locationName"));
//                                        records.add(carViolationResult);
//                                    }
//                                }
//                            }
                            mOnQueryCarViolationListener.onQueryCarViolation(requestHandleId, carViolationResult);
                        }else{
                            mOnQueryCarViolationListener.onFail(respCode,"出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mOnQueryCarViolationListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;

        }

    }

}
