package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 空调状态信息
 */
public class AirStateInfo {
    /**
     * AC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     */
    Integer ac;
    /**
     *  PTC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     */
    Integer ptc;
    /**
     * PTC状态
     * 0x00: 关闭
     * 0x01-0x04风速等级
     * 0xFF: 无效
     */
    Integer windLevel;
    /**
     * 吹风模式
     * 0x1: face
     * 0x2: foot
     * 0x3: face&foot
     * 0xFF: 无效
     */
    Integer blowerMode;
    /**
     * 循环模式
     * 0x1: 内循环
     * 0x2: 外循环
     * 0xFF: 无效
     */
    Integer cycleMode;
    /**
     * 前除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     */
    Integer preDefrosting;
    /**
     * 后除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     */
    Integer afterDefrosting;

    /**
     * 获取 AC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @return the ac
     */
    public Integer getAc() {
        return ac;
    }

    /**
     * 设置 AC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @param ac the ac
     */
    public void setAc(Integer ac) {
        this.ac = ac;
    }

    /**
     * 获取  PTC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @return the ptc
     */
    public Integer getPtc() {
        return ptc;
    }

    /**
     * 设置  PTC状态
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @param ptc the ptc
     */
    public void setPtc(Integer ptc) {
        this.ptc = ptc;
    }

    /**
     * 获取 PTC状态
     * 0x00: 关闭
     * 0x01-0x04风速等级
     * 0xFF: 无效
     *
     * @return the wind level
     */
    public Integer getWindLevel() {
        return windLevel;
    }

    /**
     * 设置 PTC状态
     * 0x00: 关闭
     * 0x01-0x04风速等级
     * 0xFF: 无效
     *
     * @param windLevel the wind level
     */
    public void setWindLevel(Integer windLevel) {
        this.windLevel = windLevel;
    }

    /**
     * 获取 吹风模式
     * 0x1: face
     * 0x2: foot
     * 0x3: face&foot
     * 0xFF: 无效
     *
     * @return the blower mode
     */
    public Integer getBlowerMode() {
        return blowerMode;
    }

    /**
     * 设置 吹风模式
     * 0x1: face
     * 0x2: foot
     * 0x3: face&foot
     * 0xFF: 无效
     *
     * @param blowerMode the blower mode
     */
    public void setBlowerMode(Integer blowerMode) {
        this.blowerMode = blowerMode;
    }

    /**
     * 获取 循环模式
     * 0x1: 内循环
     * 0x2: 外循环
     * 0xFF: 无效
     *
     * @return the cycle mode
     */
    public Integer getCycleMode() {
        return cycleMode;
    }

    /**
     * 设置 循环模式
     * 0x1: 内循环
     * 0x2: 外循环
     * 0xFF: 无效
     *
     * @param cycleMode the cycle mode
     */
    public void setCycleMode(Integer cycleMode) {
        this.cycleMode = cycleMode;
    }

    /**
     * 获取 前除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @return the pre defrosting
     */
    public Integer getPreDefrosting() {
        return preDefrosting;
    }

    /**
     * 设置 前除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @param preDefrosting the pre defrosting
     */
    public void setPreDefrosting(Integer preDefrosting) {
        this.preDefrosting = preDefrosting;
    }

    /**
     * 获取 后除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @return the after defrosting
     */
    public Integer getAfterDefrosting() {
        return afterDefrosting;
    }

    /**
     * 设置 后除霜
     * 0x1: active
     * 0x2: Inactive
     * 0xFF: 无效
     *
     * @param afterDefrosting the after defrosting
     */
    public void setAfterDefrosting(Integer afterDefrosting) {
        this.afterDefrosting = afterDefrosting;
    }
}
