package com.mxnavi.tspv2.remotecontrol.model;

import android.os.Parcel;
import android.os.Parcelable;

import org.json.JSONObject;

/**
 * Created by Administrator on 2017/9/4.
 */

public class CarState implements Parcelable {
    int respCode;
    String msg;
    String requestId;
    String instruction;
    String deviceNo;
    String productId;
    String userId;
    String stateDataJson;
    public CarState(){

    }
    protected CarState(Parcel in) {
        respCode = in.readInt();
        msg = in.readString();
        requestId = in.readString();
        instruction = in.readString();
        deviceNo = in.readString();
        productId = in.readString();
        userId = in.readString();
        stateDataJson = in.readString();

    }
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(respCode);
        dest.writeString(msg);
        dest.writeString(requestId);
        dest.writeString(instruction);
        dest.writeString(deviceNo);
        dest.writeString(productId);
        dest.writeString(userId);
        dest.writeString(stateDataJson);
    }
    public static final Creator<CarState> CREATOR = new Creator<CarState>() {
        @Override
        public CarState createFromParcel(Parcel in) {
            return new CarState(in);
        }

        @Override
        public CarState[] newArray(int size) {
            return new CarState[size];
        }
    };

    public int getRespCode() {
        return respCode;
    }
    /**
     * 设置车机响应吗（必填）
     * @param respCode
     */
    public void setRespCode(int respCode) {
        this.respCode = respCode;
    }

    public String getMsg() {
        return msg;
    }

    /**
     * 设置错误信息（非必填）
     * @param msg
     */
    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getRequestId() {
        return requestId;
    }
    /**
     * 设置命令请求ID（必填）
     * @param requestId
     */
    public void setRequestId(String requestId) {
        this.requestId = requestId;
    }

    public String getInstruction() {
        return instruction;
    }
    /**
     * 设置控制指令码，详见接口文档（必填）
     * @param instruction
     */
    public void setInstruction(String instruction) {
        this.instruction = instruction;
    }

    public String getDeviceNo() {
        return deviceNo;
    }
    /**
     * 设置车辆识别码（必填）
     * @param deviceNo
     */
    public void setDeviceNo(String deviceNo) {
        this.deviceNo = deviceNo;
    }

    public String getProductId() {
        return productId;
    }
    /**
     * 设置产品系列（必填）
     * @param productId
     */
    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getUserId() {
        return userId;
    }
    /**
     * 设置登录用户ID（必填）
     * @param userId
     */
    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getStateDataJson() {
        return stateDataJson;
    }
    /**
     * 车辆状态对象（请求参数instruction 为100时返回，具体参数车机端和手机端确认）
     * @param stateData
     */
    public void setStateDataJson(String stateDataJson) {
        this.stateDataJson = stateDataJson;
    }

}
