package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 空调控制消息(请求/应答)
 * app->服务器 请求时：
 * 如果只传"ctrl_air_message"中的"request_id"和"common_param"，表示"查询"指令，
 * 服务器应答消息中需包含"ctrl_air_message"和"resp_code"数据(失败时，只包含"ctrl_air_message"中"request_id"和"resp_code")
 * 如果除"resp_code"以外全部数据，表示"控制"指令，服务器应答消息中只包含"ctrl_air_message"中"request_id"和"resp_code"
 */
public class CtrlAirMobileMsg {
    /**
     * 安防密码
     */
    String safePassword;
    /**
     * 通用参数
     */
    CtrlCommonParamMobile commonParam;
    /**
     * 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     */
    Integer respCode;
    /**
     * 空调控制消息
     */
    CtrlAirMessage airMessage;

    /**
     * 获取 安防密码
     *
     * @return the safe password
     */
    public String getSafePassword() {
        return safePassword;
    }

    /**
     * 设置 安防密码
     *
     * @param safePassword the safe password
     */
    public void setSafePassword(String safePassword) {
        this.safePassword = safePassword;
    }

    /**
     * 获取 通用参数
     *
     * @return the common param
     */
    public CtrlCommonParamMobile getCommonParam() {
        return commonParam;
    }

    /**
     * 设置 通用参数
     *
     * @param commonParam the common param
     */
    public void setCommonParam(CtrlCommonParamMobile commonParam) {
        this.commonParam = commonParam;
    }

    /**
     * 获取 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     *
     * @return the resp code
     */
    public Integer getRespCode() {
        return respCode;
    }

    /**
     * 设置 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     *
     * @param respCode the resp code
     */
    public void setRespCode(Integer respCode) {
        this.respCode = respCode;
    }

    /**
     * 获取 空调控制消息
     *
     * @return the air message
     */
    public CtrlAirMessage getAirMessage() {
        return airMessage;
    }

    /**
     * 设置 空调控制消息
     *
     * @param airMessage the air message
     */
    public void setAirMessage(CtrlAirMessage airMessage) {
        this.airMessage = airMessage;
    }
}
