package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 取得全部控制设备的状态
 *   服务器->TBOX 请求时：只传"request_id"
 *   TBOX->服务器 应答时：将请求的"request_id"传回，同时，各设备状态通过相应的"XxxxMessage"返回，
 *   各子Message内的"request_id"不要传
 */

public class CtrlAllStateMsg {
    /**
     * 通用参数
     */
    CtrlCommonParamTbox commonParam;
    /**
     * 空调控制消息
     */
    CtrlAirMessage airMessage;
    /**
     * 座椅控制消息
     */
    CtrlChairMsg chairMessage;
    /**
     * 充电控制消息
     */
    CtrlChargeMsg chargeMessage;
    /**
     * 车门控制消息
     */
    CtrlDoorsMsg doorsMessage;
    /**
     * 电子钥匙控制消息
     */
    CtrlEkeyMsg ekeyMessage;
    /**
     * 电动机控制消息
     */
    CtrlElectromotorMsg electromotorMessage;
    /**
     * 发动机控制
     */
    CtrlEngineMsg engineMessage;
    /**
     * 寻车控制消息
     */
    CtrlLightHornMsg lightHornMessage;
    /**
     * 车窗控制消息
     */
    CtrlWindowsMsg windowsMessage;
    /**
     * 油量状态
     */
    StateOilMassMsg oilMassState;
    /**
     * 蓄电池信息
     */
    StateBatteryMsg batteryState;
    /**
     * 车灯信息
     */
    StateLightingMsg lightingState;
    /**
     * 里程信息
     */
    StateMileageMsg mileageState;
    /**
     * 车胎状态
     */
    StateTyreMsg tyreState;
    /**
     * 其他状态
     */
    StateOtherMsg otherState;
    /**
     * 屏幕保护
     */
    CtrlPrivateInformationMessage privateInformationMessage;
    /**
     * 天窗控制消息
     */
    CtrlTopWindowsMsg topWindowsMessage;
    /**
     * 后备箱控制消息
     */
    CtrlTrunkDoorsMsg trunkDoorsMessage;
    /**
     * 远程空调温度设定消息
     */
    CtrlAirTemperatureMsg airTemperatureMessage;

    /**
     * 获取 通用参数
     * @return
     */
    public CtrlCommonParamTbox getCommonParam() {
        return commonParam;
    }

    /**
     * 设置 通用参数
     * @param commonParam
     */
    public void setCommon_param(CtrlCommonParamTbox commonParam) {
        this.commonParam = commonParam;
    }

    /**
     * 获取 空调控制消息
     * @return
     */
    public CtrlAirMessage getAirMessage() {
        return airMessage;
    }

    /**
     * 设置 空调控制消息
     * @param airMessage
     */
    public void setAirMessage(CtrlAirMessage airMessage) {
        this.airMessage = airMessage;
    }

    /**
     * 获取 座椅控制消息
     * @return
     */
    public CtrlChairMsg getChairMessage() {
        return chairMessage;
    }

    /**
     * 设置 座椅控制消息
     * @param chairMessage
     */
    public void setChairMessage(CtrlChairMsg chairMessage) {
        this.chairMessage = chairMessage;
    }

    /**
     * 获取 充电控制消息
     * @return
     */
    public CtrlChargeMsg getChargeMessage() {
        return chargeMessage;
    }

    /**
     * 设置 充电控制消息
     * @param chargeMessage
     */
    public void setChargeMessage(CtrlChargeMsg chargeMessage) {
        this.chargeMessage = chargeMessage;
    }

    /**
     * 获取 车门控制消息
     * @return
     */
    public CtrlDoorsMsg getDoorsMessage() {
        return doorsMessage;
    }

    /**
     * 设置 车门控制消息
     * @param doorsMessage
     */
    public void setDoorsMessage(CtrlDoorsMsg doorsMessage) {
        this.doorsMessage = doorsMessage;
    }

    /**
     * 获取 电子钥匙控制消息
     * @return
     */
    public CtrlEkeyMsg getEkeyMessage() {
        return ekeyMessage;
    }

    /**
     * 设置 电子钥匙控制消息
     * @param ekeyMessage
     */
    public void setEkeyMessage(CtrlEkeyMsg ekeyMessage) {
        this.ekeyMessage = ekeyMessage;
    }

    /**
     * 获取 电动机控制消息
     * @return
     */
    public CtrlElectromotorMsg getElectromotorMessage() {
        return electromotorMessage;
    }

    /**
     * 设置 电动机控制消息
     * @param electromotorMessage
     */
    public void setElectromotorMessage(CtrlElectromotorMsg electromotorMessage) {
        this.electromotorMessage = electromotorMessage;
    }

    /**
     * 获取 发动机控制
     * @return
     */
    public CtrlEngineMsg getEngineMessage() {
        return engineMessage;
    }

    /**
     * 设置 发动机控制
     * @param engineMessage
     */
    public void setEngineMessage(CtrlEngineMsg engineMessage) {
        this.engineMessage = engineMessage;
    }

    /**
     * 获取 寻车控制消息
     * @return
     */
    public CtrlLightHornMsg getLightHornMessage() {
        return lightHornMessage;
    }

    /**
     * 设置 寻车控制消息
     * @param lightHornMessage
     */
    public void setLightHornMessage(CtrlLightHornMsg lightHornMessage) {
        this.lightHornMessage = lightHornMessage;
    }

    /**
     * 获取 车窗控制消息
     * @return
     */
    public CtrlWindowsMsg getWindowsMessage() {
        return windowsMessage;
    }

    /**
     * 设置 车窗控制消息
     * @param windowsMessage
     */
    public void setWindowsMessage(CtrlWindowsMsg windowsMessage) {
        this.windowsMessage = windowsMessage;
    }

    /**
     * 获取 油量状态
     * @return
     */
    public StateOilMassMsg getOilMassState() {
        return oilMassState;
    }

    /**
     * 设置 油量状态
     * @param oilMassState
     */
    public void setOilMassState(StateOilMassMsg oilMassState) {
        this.oilMassState = oilMassState;
    }

    /**
     * 获取 蓄电池信息
     * @return
     */
    public StateBatteryMsg getBatteryState() {
        return batteryState;
    }

    /**
     * 设置 蓄电池信息
     * @param batteryState
     */
    public void setBatteryState(StateBatteryMsg batteryState) {
        this.batteryState = batteryState;
    }

    /**
     * 获取 车灯信息
     * @return
     */
    public StateLightingMsg getLightingState() {
        return lightingState;
    }

    /**
     * 设置 车灯信息
     * @param lightingState
     */
    public void setLightingState(StateLightingMsg lightingState) {
        this.lightingState = lightingState;
    }

    /**
     * 获取 里程信息
     * @return
     */
    public StateMileageMsg getMileageState() {
        return mileageState;
    }

    /**
     * 设置 里程信息
     * @param mileageState
     */
    public void setMileageState(StateMileageMsg mileageState) {
        this.mileageState = mileageState;
    }

    /**
     * 获取 车胎状态
     * @return
     */
    public StateTyreMsg getTyreState() {
        return tyreState;
    }

    /**
     * 设置 车胎状态
     * @param tyreState
     */
    public void setTyreState(StateTyreMsg tyreState) {
        this.tyreState = tyreState;
    }

    /**
     * 获取 其他状态
     * @return
     */
    public StateOtherMsg getOtherState() {
        return otherState;
    }

    /**
     * 设置 其他状态
     * @param otherState
     */
    public void setOtherState(StateOtherMsg otherState) {
        this.otherState = otherState;
    }

    /**
     * 获取 屏幕保护
     * @return
     */
    public CtrlPrivateInformationMessage getPrivateInformationMessage() {
        return privateInformationMessage;
    }

    /**
     * 设置 屏幕保护
     * @param privateInformationMessage
     */
    public void setPrivateInformationMessage(CtrlPrivateInformationMessage privateInformationMessage) {
        this.privateInformationMessage = privateInformationMessage;
    }

    /**
     * 获取 天窗控制消息
     * @return
     */
    public CtrlTopWindowsMsg getTopWindowsMessage() {
        return topWindowsMessage;
    }

    /**
     * 设置 天窗控制消息
     * @param topWindowsMessage
     */
    public void setTopWindowsMessage(CtrlTopWindowsMsg topWindowsMessage) {
        this.topWindowsMessage = topWindowsMessage;
    }

    /**
     * 获取 后备箱控制消息
     * @return
     */
    public CtrlTrunkDoorsMsg getTrunkDoorsMessage() {
        return trunkDoorsMessage;
    }

    /**
     * 设置 后备箱控制消息
     * @param trunkDoorsMessage
     */
    public void setTrunkDoorsMessage(CtrlTrunkDoorsMsg trunkDoorsMessage) {
        this.trunkDoorsMessage = trunkDoorsMessage;
    }

    /**
     * 获取 远程空调温度设定消息
     * @return
     */
    public CtrlAirTemperatureMsg getAirTemperatureMessage() {
        return airTemperatureMessage;
    }

    /**
     * 设置 远程空调温度设定消息
     * @param airTemperatureMessage
     */
    public void setAirTemperatureMessage(CtrlAirTemperatureMsg airTemperatureMessage) {
        this.airTemperatureMessage = airTemperatureMessage;
    }
}
