package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by cikai on 2018/8/8.
 *
 * 车灯信息
 */
public class StateLightingMsg {
    /**
     * 近光灯 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer lowBeam;
    /**
     * 远光灯 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer highBeam;
    /**
     * 左转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer leftCorneringLamp;
    /**
     * 右转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer rightCorneringLamp;
    /**
     * 轮廓灯 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer clearanceLight;
    /**
     * 雾灯状态 0x01开 0x02关 0xFF:无法得到当前状态
     */
    private Integer fogLight;

    /**
     * 获取近光灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the low beam
     */
    public Integer getLowBeam() {
        return lowBeam;
    }

    /**
     * 设置近光灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param lowBeam the low beam
     */
    public void setLowBeam(Integer lowBeam) {
        this.lowBeam = lowBeam;
    }

    /**
     * 获取远光灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the high beam
     */
    public Integer getHighBeam() {
        return highBeam;
    }

    /**
     * 设置远光灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param highBeam the high beam
     */
    public void setHighBeam(Integer highBeam) {
        this.highBeam = highBeam;
    }

    /**
     * 获取左转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the left cornering lamp
     */
    public Integer getLeftCorneringLamp() {
        return leftCorneringLamp;
    }

    /**
     * 设置左转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param leftCorneringLamp the left cornering lamp
     */
    public void setLeftCorneringLamp(Integer leftCorneringLamp) {
        this.leftCorneringLamp = leftCorneringLamp;
    }

    /**
     * 获取右转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the right cornering lamp
     */
    public Integer getRightCorneringLamp() {
        return rightCorneringLamp;
    }

    /**
     * 设置右转向灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param rightCorneringLamp the right cornering lamp
     */
    public void setRightCorneringLamp(Integer rightCorneringLamp) {
        this.rightCorneringLamp = rightCorneringLamp;
    }

    /**
     * 获取轮廓灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the clearance light
     */
    public Integer getClearanceLight() {
        return clearanceLight;
    }

    /**
     * 设置轮廓灯 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param clearanceLight the clearance light
     */
    public void setClearanceLight(Integer clearanceLight) {
        this.clearanceLight = clearanceLight;
    }

    /**
     * 获取雾灯状态 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @return the fog light
     */
    public Integer getFogLight() {
        return fogLight;
    }

    /**
     * 设置雾灯状态 0x01开 0x02关 0xFF:无法得到当前状态
     *
     * @param fogLight the fog light
     */
    public void setFogLight(Integer fogLight) {
        this.fogLight = fogLight;
    }
}
