package com.mxnavi.tspv2.search.model;

import android.os.Parcel;
import android.os.Parcelable;
import android.os.Parcelable.Creator;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by lenovo on 2016/6/12.
 */
public class AddrInfo implements Parcelable{
    String adminCode;
    Double minDistance;
    String cityName;
    String cityCode;
    String distName;
    LatLng location;
    String provCode;
    String provName;

    /**
     * 获取 经纬度
     * @return
     */
    public LatLng getLocation() {
        return location;
    }

    /**
     * 设置 经纬度
     * @param location
     */
    public void setLocation(LatLng location) {
        this.location = location;
    }

    /**
     * 获取 行政区code （八位行政区的十进制表示）
     * @return
     */
    public String getAdminCode() {
        return adminCode;
    }

    /**
     * 设置 行政区code （八位行政区的十进制表示）
     * @param adminCode
     */
    public void setAdminCode(String adminCode) {
        this.adminCode = adminCode;
    }

    /**
     * 获取 该Point离所在行政区边界最小距离
     * @return
     */
    public Double getMinDistance() {
        return minDistance;
    }

    /**
     * 设置 该Point离所在行政区边界最小距离
     * @param minDistance
     */
    public void setMinDistance(Double minDistance) {
        this.minDistance = minDistance;
    }

    /**
     * 获取 市名称
     * @return
     */
    public String getCity() {
        return cityName;
    }

    /**
     * 设置 市名称
     * @param city
     */
    public void setCity(String city) {
        this.cityName = city;
    }

    /**
     * 获取 市Code
     * @return
     */
    public String getCityCode() {
        return cityCode;
    }

    /**
     * 设置 市Code
     * @param cityCode
     */
    public void setCityCode(String cityCode) {
        this.cityCode = cityCode;
    }

    /**
     * 获取 区县名称
     * @return
     */
    public String getDist() {
        return distName;
    }

    /**
     * 设置 区县名称
     * @param dist
     */
    public void setDist(String dist) {
        this.distName = dist;
    }

    /**
     * 获取 省Code
     * @return
     */
    public String getProvCode() {
        return provCode;
    }

    /**
     * 设置 省Code
     * @param provCode
     */
    public void setProvCode(String provCode) {
        this.provCode = provCode;
    }

    /**
     * 获取 省名称
     * @return
     */
    public String getProvince() {
        return provName;
    }

    /**
     * 设置 省名称
     * @param province
     */
    public void setProvince(String province) {
        this.provName = province;
    }
    public AddrInfo(){
    	
    }
    protected AddrInfo(Parcel in) {
        adminCode = in.readString();
        minDistance = in.readDouble();
        cityName = in.readString();
        cityCode = in.readString();
        distName = in.readString();     
        location = in.readParcelable(LatLng.class.getClassLoader());
        provCode = in.readString();
        provName = in.readString();
    }
    public static final Creator<AddrInfo> CREATOR = new Creator<AddrInfo>() {
        @Override
        public AddrInfo createFromParcel(Parcel in) {
            return new AddrInfo(in);
        }

        @Override
        public AddrInfo[] newArray(int size) {
            return new AddrInfo[size];
        }
    };
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(adminCode);
        dest.writeDouble(minDistance);
        dest.writeString(cityName);
        dest.writeString(cityCode);
        dest.writeString(distName);
        dest.writeParcelable(location,flags);
        dest.writeString(provCode);
        dest.writeString(provName);
    }
    
}
