package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.TspTime;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/3/17.
 */
public class CurrentWeather implements Parcelable,Serializable {
    private static final long serialVersionUID = 1L;
    /* 温度(单位:摄氏度)(999为未知) */
    private int currentTmp = 0;

    /* 湿度(%)(-1为未知) */
    private int damp = 0;

    /* 天气现象ID */
    private int weatherId = 0;

    /* 天气现象描述 */
    private String	weatherName = null;

    /* 风力ID */
    private int windLevelId = 0;

    /* 风力描述 */
    private String	windLevelName = null;

    /* 风向ID */
    private int windOrientationId = 0;

    /* 风向描述 */
    private String	 windOrientaionName = null;

    /* 实况发布时间 */
    private TspTime pubTime = null;

    public CurrentWeather() {
    }

    public CurrentWeather(int currentTmp, int damp, int weatherId, String weatherName, int windLevelId, String windLevelName, int windOrientationId, String windOrientaionName, TspTime pubTime) {
        this.currentTmp = currentTmp;
        this.damp = damp;
        this.weatherId = weatherId;
        this.weatherName = weatherName;
        this.windLevelId = windLevelId;
        this.windLevelName = windLevelName;
        this.windOrientationId = windOrientationId;
        this.windOrientaionName = windOrientaionName;
        this.pubTime = pubTime;
    }

    protected CurrentWeather(Parcel in) {
        currentTmp = in.readInt();
        damp = in.readInt();
        weatherId = in.readInt();
        weatherName = in.readString();
        windLevelId = in.readInt();
        windLevelName = in.readString();
        windOrientationId = in.readInt();
        windOrientaionName = in.readString();
        pubTime = in.readParcelable(TspTime.class.getClassLoader());
    }

    public static final Creator<CurrentWeather> CREATOR = new Creator<CurrentWeather>() {
        @Override
        public CurrentWeather createFromParcel(Parcel in) {
            return new CurrentWeather(in);
        }

        @Override
        public CurrentWeather[] newArray(int size) {
            return new CurrentWeather[size];
        }
    };

    /**
     * 获取温度
     * @return 温度
     */
    public int getCurrentTmp() {
        return currentTmp;
    }

    /**
     * 设置温度
     * @param currentTmp
     */
    public void setCurrentTmp(int currentTmp) {
        this.currentTmp = currentTmp;
    }

    /**
     * 获取湿度
     * @return 湿度
     */
    public int getDamp() {
        return damp;
    }

    /**
     * 设置湿度
     * @param damp
     */
    public void setDamp(int damp) {
        this.damp = damp;
    }

    /**
     * 获取天气现象ID
     * @return 天气现象ID
     */
    public int getWeatherId() {
        return weatherId;
    }

    /**
     * 设置天气现象ID
     * @param weatherId
     */
    public void setWeatherId(int weatherId) {
        this.weatherId = weatherId;
    }

    /**
     * 获取天气现象描述
     * @return 天气现象描述
     */
    public String getWeatherName() {
        return weatherName;
    }

    /**
     * 设置天气现象描述
     * @param weatherName
     */
    public void setWeatherName(String weatherName) {
        this.weatherName = weatherName;
    }

    /**
     * 获取风力ID
     * @return 风力ID
     */
    public int getWindLevelId() {
        return windLevelId;
    }

    /**
     * 设置风力ID
     * @param windLevelId
     */
    public void setWindLevelId(int windLevelId) {
        this.windLevelId = windLevelId;
    }

    /**
     * 获取风力描述
     * @return 风力描述
     */
    public String getWindLevelName() {
        return windLevelName;
    }

    /**
     * 设置风力描述
     * @param windLevelName
     */
    public void setWindLevelName(String windLevelName) {
        this.windLevelName = windLevelName;
    }

    /**
     * 获取风向ID
     * @return 风向ID
     */
    public int getWindOrientationId() {
        return windOrientationId;
    }

    /**
     * 设置风向ID
     * @param windOrientationId
     */
    public void setWindOrientationId(int windOrientationId) {
        this.windOrientationId = windOrientationId;
    }

    /**
     * 获取风向描述
     * @return 风向描述
     */
    public String getWindOrientaionName() {
        return windOrientaionName;
    }

    /**
     * 设置风向描述
     * @param windOrientaionName
     */
    public void setWindOrientaionName(String windOrientaionName) {
        this.windOrientaionName = windOrientaionName;
    }

    /**
     * 获取实况发布时间
     * @return 实况发布时间
     */
    public TspTime getPubTime() {
        return pubTime;
    }

    /**
     * 设置实况发布时间
     * @param pubTime
     */
    public void setPubTime(TspTime pubTime) {
        this.pubTime = pubTime;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(currentTmp);
        dest.writeInt(damp);
        dest.writeInt(weatherId);
        dest.writeString(weatherName);
        dest.writeInt(windLevelId);
        dest.writeString(windLevelName);
        dest.writeInt(windOrientationId);
        dest.writeString(windOrientaionName);
        dest.writeParcelable(pubTime, flags);
    }
}
