package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.TspDate;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/3/17.
 */
public class FutureWeather implements Parcelable,Serializable {
    private static final long serialVersionUID = 1L;

    /* 日期 yyyy-MM-dd */
    TspDate date;
    /* 白天温度 */
    int tmpDay;
   /* 夜晚温度 */
    int tmpNight;
   /* 白天天气现象ID */
    int wphDayId;
   /* 白天天气现象名称 */
    String wphDayName;
   /* 夜晚天气现象ID */
    int wphNightId;
   /* 夜晚天气现象名称 */
    String wphNightName;
   /* 白天风力ID */
    int windDayLevelId;
   /* 白天风力描述 */
    String windDayLevelName;
   /* 白天风向ID */
    int windDayOrientationId;
   /* 白天风向描述 */
    String windDayOrientationName;
   /* 夜晚风力ID */
    int windNightLevelId;
   /* 夜晚风力描述 */
    String windNightLevelName;
   /* 夜晚风向ID */
    int windNightOrientationId;
   /* 夜晚风向描述 */
    String windNightOrientationName;

    public FutureWeather() {
    }

    public FutureWeather(TspDate date, int tmpDay, int tmpNight, int wphDayId, String wphDayName, int wphNightId, String wphNightName, int windDayLevelId, String windDayLevelName, int windDayOrientationId, String windDayOrientationName, int windNightLevelId, String windNightLevelName, int windNightOrientationId, String windNightOrientationName) {
        this.date = date;
        this.tmpDay = tmpDay;
        this.tmpNight = tmpNight;
        this.wphDayId = wphDayId;
        this.wphDayName = wphDayName;
        this.wphNightId = wphNightId;
        this.wphNightName = wphNightName;
        this.windDayLevelId = windDayLevelId;
        this.windDayLevelName = windDayLevelName;
        this.windDayOrientationId = windDayOrientationId;
        this.windDayOrientationName = windDayOrientationName;
        this.windNightLevelId = windNightLevelId;
        this.windNightLevelName = windNightLevelName;
        this.windNightOrientationId = windNightOrientationId;
        this.windNightOrientationName = windNightOrientationName;
    }

    protected FutureWeather(Parcel in) {
        date = in.readParcelable(TspDate.class.getClassLoader());
        tmpDay = in.readInt();
        tmpNight = in.readInt();
        wphDayId = in.readInt();
        wphDayName = in.readString();
        wphNightId = in.readInt();
        wphNightName = in.readString();
        windDayLevelId = in.readInt();
        windDayLevelName = in.readString();
        windDayOrientationId = in.readInt();
        windDayOrientationName = in.readString();
        windNightLevelId = in.readInt();
        windNightLevelName = in.readString();
        windNightOrientationId = in.readInt();
        windNightOrientationName = in.readString();
    }

    public static final Creator<FutureWeather> CREATOR = new Creator<FutureWeather>() {
        @Override
        public FutureWeather createFromParcel(Parcel in) {
            return new FutureWeather(in);
        }

        @Override
        public FutureWeather[] newArray(int size) {
            return new FutureWeather[size];
        }
    };

    /**
     * 获取日期
     * @return 日期
     */
    public TspDate getDate() {
        return date;
    }

    /**
     * 设置日期
     * @param date
     */
    public void setDate(TspDate date) {
        this.date = date;
    }

    /**
     * 获取白天温度
     * @return 白天温度
     */
    public int getTmpDay() {
        return tmpDay;
    }

    /**
     * 设置白天温度
     * @param tmpDay
     */
    public void setTmpDay(int tmpDay) {
        this.tmpDay = tmpDay;
    }

    /**
     * 获取夜晚温度
     * @return 夜晚温度
     */
    public int getTmpNight() {
        return tmpNight;
    }

    /**
     * 设置夜晚温度
     * @param tmpNight
     */
    public void setTmpNight(int tmpNight) {
        this.tmpNight = tmpNight;
    }

    /**
     * 获取白天天气现象ID
     * @return 白天天气现象ID
     */
    public int getWphDayId() {
        return wphDayId;
    }

    /**
     * 设置白天天气现象ID
     * @param wphDayId
     */
    public void setWphDayId(int wphDayId) {
        this.wphDayId = wphDayId;
    }

    /**
     * 获取白天天气现象名称
     * @return 白天天气现象名称
     */
    public String getWphDayName() {
        return wphDayName;
    }

    /**
     * 设置白天天气现象名称
     * @param wphDayName
     */
    public void setWphDayName(String wphDayName) {
        this.wphDayName = wphDayName;
    }

    /**
     * 获取夜晚天气现象ID
     * @return 夜晚天气现象ID
     */
    public int getWphNightId() {
        return wphNightId;
    }

    /**
     * 设置夜晚天气现象ID
     * @param wphNightId
     */
    public void setWphNightId(int wphNightId) {
        this.wphNightId = wphNightId;
    }

    /**
     * 获取夜晚天气现象名称
     * @return 夜晚天气现象名称
     */
    public String getWphNightName() {
        return wphNightName;
    }

    /**
     * 设置夜晚天气现象名称
     * @param wphNightName
     */
    public void setWphNightName(String wphNightName) {
        this.wphNightName = wphNightName;
    }

    /**
     * 获取白天风力ID
     * @return 白天风力ID
     */
    public int getWindDayLevelId() {
        return windDayLevelId;
    }

    /**
     * 设置白天风力ID
     * @param windDayLevelId
     */
    public void setWindDayLevelId(int windDayLevelId) {
        this.windDayLevelId = windDayLevelId;
    }

    /**
     * 获取白天风力描述
     * @return 白天风力描述
     */
    public String getWindDayLevelName() {
        return windDayLevelName;
    }

    /**
     * 设置白天风力描述
     * @param windDayLevelName
     */
    public void setWindDayLevelName(String windDayLevelName) {
        this.windDayLevelName = windDayLevelName;
    }

    /**
     * 获取白天风向ID
     * @return 白天风向ID
     */
    public int getWindDayOrientationId() {
        return windDayOrientationId;
    }

    /**
     * 设置白天风向ID
     * @param windDayOrientationId
     */
    public void setWindDayOrientationId(int windDayOrientationId) {
        this.windDayOrientationId = windDayOrientationId;
    }

    /**
     * 获取白天风向描述
     * @return 白天风向描述
     */
    public String getWindDayOrientationName() {
        return windDayOrientationName;
    }

    /**
     * 设置白天风向描述
     * @param windDayOrientationName
     */
    public void setWindDayOrientationName(String windDayOrientationName) {
        this.windDayOrientationName = windDayOrientationName;
    }

    /**
     * 获取夜晚风力ID
     * @return 夜晚风力ID
     */
    public int getWindNightLevelId() {
        return windNightLevelId;
    }

    /**
     * 设置夜晚风力ID
     * @param windNightLevelId
     */
    public void setWindNightLevelId(int windNightLevelId) {
        this.windNightLevelId = windNightLevelId;
    }

    /**
     * 获取夜晚风力描述
     * @return 夜晚风力描述
     */
    public String getWindNightLevelName() {
        return windNightLevelName;
    }

    /**
     * 设置夜晚风力描述
     * @param windNightLevelName
     */
    public void setWindNightLevelName(String windNightLevelName) {
        this.windNightLevelName = windNightLevelName;
    }

    /**
     * 获取夜晚风向ID
     * @return 夜晚风向ID
     */
    public int getWindNightOrientationId() {
        return windNightOrientationId;
    }

    /**
     * 设置夜晚风向ID
     * @param windNightOrientationId
     */
    public void setWindNightOrientationId(int windNightOrientationId) {
        this.windNightOrientationId = windNightOrientationId;
    }

    /**
     * 获取夜晚风向描述
     * @return 夜晚风向描述
     */
    public String getWindNightOrientationName() {
        return windNightOrientationName;
    }

    /**
     * 设置夜晚风向描述
     * @param windNightOrientationName
     */
    public void setWindNightOrientationName(String windNightOrientationName) {
        this.windNightOrientationName = windNightOrientationName;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeParcelable(date, flags);
        dest.writeInt(tmpDay);
        dest.writeInt(tmpNight);
        dest.writeInt(wphDayId);
        dest.writeString(wphDayName);
        dest.writeInt(wphNightId);
        dest.writeString(wphNightName);
        dest.writeInt(windDayLevelId);
        dest.writeString(windDayLevelName);
        dest.writeInt(windDayOrientationId);
        dest.writeString(windDayOrientationName);
        dest.writeInt(windNightLevelId);
        dest.writeString(windNightLevelName);
        dest.writeInt(windNightOrientationId);
        dest.writeString(windNightOrientationName);
    }
}
