package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Administrator on 2016/4/22.
 * desc
 */
public class NormalWeatherQuery implements Parcelable{
    int futureDays;
    List<LatLng> locations;
    List<String> cityCodes;
    int locationType;
    /**
     * 获取未来几天天气  取值：0-3
     * @return 取未来几天天气  取值：0-3
     */
    public int getFutureDays() {
        return futureDays;
    }

    /**
     * 设置未来几天天气  取值：0-3
     * @param futureDays
     */
    public void setFutureDays(int futureDays) {
        this.futureDays = futureDays;
    }

    /**
     * 获取经纬度集合
     * @return 经纬度集合
     */
    public List<LatLng> getLocations() {
        return locations;
    }

    /**
     * 设置经纬度集合
     * @param locations
     */
    public void setLocations(List<LatLng> locations) {
        this.locations = locations;
    }

    public List<String> getCityCodes() {
        return cityCodes;
    }

    /**
     * 设置行政区code
     * @param cityCodes
     */
    public void setCityCodes(List<String> cityCodes) {
        this.cityCodes = cityCodes;
    }

    public int getLocationType() {
        return locationType;
    }

    /**
     * 设置查询天气区域类型，目前只支持经纬度查询，1-通过经纬度查询,则向属性locations中设置经纬度参数，0-通过行政区code查询，则向属性cityCodes中设置行政区code
     * @param locationType
     */
    public void setLocationType(int locationType) {
        this.locationType = locationType;
    }

    public static final Creator<NormalWeatherQuery> CREATOR = new Creator(){

        @Override
        public NormalWeatherQuery createFromParcel(Parcel source) {
            // TODO Auto-generated method stub
            // 必须按成员变量声明的顺序读取数据，不然会出现获取数据出错
            NormalWeatherQuery p = new NormalWeatherQuery();
            p.setFutureDays(source.readInt());
            if(p.locations==null){
                p.locations = new ArrayList<LatLng>();
            }
            source.readTypedList(p.locations,LatLng.CREATOR);
            if(p.cityCodes==null){
                p.cityCodes = new ArrayList<String>();
            }
            source.readList(p.cityCodes,String.class.getClassLoader());
            p.setLocationType(source.readInt());
            return p;
        }

        @Override
        public NormalWeatherQuery[] newArray(int size) {
            // TODO Auto-generated method stub
            return new NormalWeatherQuery[size];
        }
    };
    @Override
    public int describeContents() {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        // TODO Auto-generated method stub
        // 1.必须按成员变量声明的顺序封装数据，不然会出现获取数据出错
        // 2.序列化对象
        dest.writeInt(futureDays);
        dest.writeTypedList(locations);
        dest.writeList(cityCodes);
        dest.writeInt(locationType);
    }

}
