package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Administrator on 2016/5/12.
 * desc
 */
public class WeatherQuery implements Parcelable {
    List<LatLng> locations;
    List<String> cityCodes;
    int locationType;

    public WeatherQuery() {
    }

    /**
     * 获取经纬度集合
     * @return 经纬度集合
     */
    public List<LatLng> getLocations() {
        return locations;
    }

    /**
     * 设置经纬度集合
     * @param locations
     */
    public void setLocations(List<LatLng> locations) {
        this.locations = locations;
    }

    /**
     * 获取行政区code
     * @return 行政区code
     */
    public List<String> getCityCodes() {
        return cityCodes;
    }

    /**
     * 设置行政区code
     * @param cityCodes
     */
    public void setCityCodes(List<String> cityCodes) {
        this.cityCodes = cityCodes;
    }

    /**
     * 获取查询天气区域类型
     * @return 查询天气区域类型
     */
    public int getLocationType() {
        return locationType;
    }

    /**
     * 设置查询天气区域类型，目前只支持经纬度查询，1-通过经纬度查询,则向属性locations中设置经纬度参数，0-通过行政区code查询，则向属性cityCodes中设置行政区code
     * @param locationType
     */
    public void setLocationType(int locationType) {
        this.locationType = locationType;
    }

    protected WeatherQuery(Parcel in) {
        locations = in.createTypedArrayList(LatLng.CREATOR);
        cityCodes = in.createStringArrayList();
        locationType = in.readInt();
    }
    public static final Creator<WeatherQuery> CREATOR = new Creator<WeatherQuery>() {
        @Override
        public WeatherQuery createFromParcel(Parcel in) {
            return new WeatherQuery(in);
        }

        @Override
        public WeatherQuery[] newArray(int size) {
            return new WeatherQuery[size];
        }
    };

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeTypedList(locations);
        dest.writeStringList(cityCodes);
        dest.writeInt(locationType);
    }
}
